
(*==========================================================================;
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:	d3d.h
 *  Content:	Direct3D include file
 *
 ***************************************************************************)

unit D3D;

interface

{$Z4}
{$A+}

uses Windows, D3DTypes, D3DCaps, DDraw;

(*
 * Interface IID's
 *)

const
  IID_IDirect3D: TGUID = (D1:$3BBA0080;D2:$2421;D3:$11CF;D4:($A3,$1A,$00,$AA,$00,$B9,$33,$56));
  IID_IDirect3D2: TGUID = (D1:$6aae1ec1;D2:$662a;D3:$11d0;D4:($88,$9d,$00,$aa,$00,$bb,$b7,$6a));

  IID_IDirect3DRampDevice: TGUID = (D1:$F2086B20;D2:$259F;D3:$11CF;D4:($A3,$1A,$00,$AA,$00,$B9,$33,$56));
  IID_IDirect3DRGBDevice: TGUID = (D1:$A4665C60;D2:$2673;D3:$11CF;D4:($A3,$1A,$00,$AA,$00,$B9,$33,$56));
  IID_IDirect3DHALDevice: TGUID = (D1:$84E63dE0;D2:$46AA;D3:$11CF;D4:($81,$6F,$00,$00,$C0,$20,$15,$6E));
  IID_IDirect3DMMXDevice: TGUID = (D1:$881949a1;D2:$d6f3;D3:$11d0;D4:($89,$ab,$00,$a0,$c9,$05,$41,$29));

  IID_IDirect3DDevice: TGUID = (D1:$64108800;D2:$957d;D3:$11d0;D4:($89,$ab,$00,$a0,$c9,$05,$41,$29));
  IID_IDirect3DDevice2: TGUID = (D1:$93281501;D2:$8cf8;D3:$11d0;D4:($89,$ab,$0,$a0,$c9,$5,$41,$29));
  IID_IDirect3DTexture: TGUID = (D1:$2CDCD9E0;D2:$25A0;D3:$11CF;D4:($A3,$1A,$00,$AA,$00,$B9,$33,$56));
  IID_IDirect3DTexture2: TGUID = (D1:$93281502;D2:$8cf8;D3:$11d0;D4:($89, $ab, $0, $a0, $c9, $5, $41, $29));
  IID_IDirect3DLight: TGUID = (D1:$4417C142;D2:$33AD;D3:$11CF;D4:($81,$6F,$00,$00,$C0,$20,$15,$6E));
  IID_IDirect3DMaterial: TGUID = (D1:$4417C144;D2:$33AD;D3:$11CF;D4:($81,$6F,$00,$00,$C0,$20,$15,$6E));
  IID_IDirect3DMaterial2: TGUID = (D1:$93281503;D2:$8cf8;D3:$11d0;D4:($89, $ab, $0, $a0, $c9, $5, $41, $29));
  IID_IDirect3DExecuteBuffer: TGUID = (D1:$4417C145;D2:$33AD;D3:$11CF;D4:($81,$6F,$00,$00,$C0,$20,$15,$6E));
  IID_IDirect3DViewport: TGUID = (D1:$4417C146;D2:$33AD;D3:$11CF;D4:($81,$6F,$00,$00,$C0,$20,$15,$6E));
  IID_IDirect3DViewport2: TGUID = (D1:$93281500;D2:$8cf8;D3:$11d0;D4:($89, $ab, $0, $a0, $c9, $5, $41, $29));

(*
 * Data structures
 *)

type
  IDirect3D = interface;
  IDirect3D2 = interface;
  IDirect3DDevice = interface;
  IDirect3DDevice2 = interface;
  IDirect3DExecuteBuffer = interface;
  IDirect3DLight = interface;
  IDirect3DMaterial = interface;
  IDirect3DMaterial2 = interface;
  IDirect3DTexture = interface;
  IDirect3DTexture2 = interface;
  IDirect3DViewport = interface;
  IDirect3DViewport2 = interface;

(*
 * IDirect3D
 *)

  IDirect3D = interface(IUnknown)
    ['{3BBA0080-2421-11CF-A31A-00AA00B93356}']
    (*** IDirect3D methods ***)
    function Initialize(const lpREFIID: TGUID): HRESULT; stdcall;
    function EnumDevices(lpEnumDevicesCallback: LPD3DENUMDEVICESCALLBACK;
        lpUserArg: Pointer): HRESULT; stdcall;
    function CreateLight(out lplpDirect3Dlight: IDirect3DLight;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function CreateMaterial(out lplpDirect3DMaterial: IDirect3DMaterial;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function CreateViewport(out lplpD3DViewport: IDirect3DViewport;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function FindDevice(const lpD3DFDS: D3DFINDDEVICESEARCH;
        var lpD3DFDR: D3DFINDDEVICERESULT): HRESULT; stdcall;
  end;

(*
 * IDirect3D2
 *)

  IDirect3D2 = interface(IUnknown)
    ['{6AAE1EC1-662A-11D0-889D-00AA00BBB76A}']
    (*** IDirect3D methods ***)
    function EnumDevices(lpEnumDevicesCallback: LPD3DENUMDEVICESCALLBACK;
        lpUserArg: Pointer): HRESULT; stdcall;
    function CreateLight(out lplpDirect3Dlight: IDirect3DLight;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function CreateMaterial(out lplpDirect3DMaterial2: IDirect3DMaterial2;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function CreateViewport(out lplpD3DViewport2: IDirect3DViewport2;
        pUnkOuter: IUnknown ): HRESULT; stdcall;
    function FindDevice(const lpD3DFDS: D3DFINDDEVICESEARCH;
        var lpD3DFDR: D3DFINDDEVICERESULT): HRESULT; stdcall;
    function CreateDevice(const rclsid: TGUID; lpDDS: IDirectDrawSurface;
        out lplpD3DDevice2: IDirect3DDevice2): HRESULT; stdcall;
  end;

(*
 * IDirect3DDevice
 *)

  IDirect3DDevice = interface(IUnknown)
    ['{64108800-957D-11D0-89AB-00A0C9054129}']
    (*** IDirect3DDevice methods ***)
    function Initialize(lpd3d: IDirect3D; const lpGUID: TGUID;
        const lpd3ddvdesc: D3DDEVICEDESC): HRESULT; stdcall;
    function GetCaps(var lpD3DHWDevDesc: D3DDEVICEDESC;
        var lpD3DHELDevDesc: D3DDEVICEDESC): HRESULT; stdcall;
    function SwapTextureHandles(lpD3DTex1: IDirect3DTexture;
        lpD3DTex2: IDirect3DTexture): HRESULT; stdcall;
    function CreateExecuteBuffer(const lpDesc: D3DEXECUTEBUFFERDESC;
        out lplpDirect3DExecuteBuffer: IDirect3DExecuteBuffer;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function GetStats(var lpD3DStats: D3DSTATS): HRESULT; stdcall;
    function Execute(lpDirect3DExecuteBuffer: IDirect3DExecuteBuffer;
        lpDirect3DViewport: IDirect3DViewport; dwFlags: DWORD): HRESULT;
        stdcall;
    function AddViewport(lpDirect3DViewport: IDirect3DViewport): HRESULT;
        stdcall;
    function DeleteViewport(lpDirect3DViewport: IDirect3DViewport): HRESULT;
        stdcall;
    function NextViewport(lpDirect3DViewport: IDirect3DViewport;
        out lplpDirect3DViewport: IDirect3DViewport; dwFlags: DWORD):
        HRESULT; stdcall;
    function Pick(lpDirect3DExecuteBuffer: IDirect3DExecuteBuffer;
        lpDirect3DViewport: IDirect3DViewport; dwFlags: DWORD;
        const lpRect: D3DRECT): HRESULT; stdcall;
    function GetPickRecords(var lpCount: DWORD;
        var lpD3DPickRec: D3DPICKRECORD): HRESULT; stdcall;
    function EnumTextureFormats(lpd3dEnumTextureProc:
        LPD3DENUMTEXTUREFORMATSCALLBACK; lpArg: Pointer): HRESULT; stdcall;
    function CreateMatrix(var lpD3DMatHandle: D3DMATRIXHANDLE): HRESULT;
        stdcall;
    function SetMatrix(d3dMatHandle: D3DMATRIXHANDLE;
        const lpD3DMatrix: D3DMATRIX): HRESULT; stdcall;
    function GetMatrix(lpD3DMatHandle: D3DMATRIXHANDLE;
        var lpD3DMatrix: D3DMATRIX): HRESULT; stdcall;
    function DeleteMatrix(d3dMatHandle: D3DMATRIXHANDLE): HRESULT; stdcall;
    function BeginScene: HRESULT; stdcall;
    function EndScene: HRESULT; stdcall;
    function GetDirect3D(out lpD3D: IDirect3D): HRESULT; stdcall;
  end;

(*
 * IDirect3DDevice2
 *)

  IDirect3DDevice2 = interface(IUnknown)
    ['{93281501-8CF8-11D0-89AB-00A0C9054129}']
    (*** IDirect3DDevice2 methods ***)
    function GetCaps(var lpD3DHWDevDesc: D3DDEVICEDESC;
        var lpD3DHELDevDesc: D3DDEVICEDESC): HRESULT; stdcall;
    function SwapTextureHandles(lpD3DTex1: IDirect3DTexture2;
        lpD3DTex2: IDirect3DTexture2): HRESULT; stdcall;
    function GetStats(var lpD3DStats: D3DSTATS): HRESULT; stdcall;
    function AddViewport(lpDirect3DViewport2: IDirect3DViewport2): HRESULT;
        stdcall;
    function DeleteViewport(lpDirect3DViewport: IDirect3DViewport2): HRESULT;
        stdcall;
    function NextViewport(lpDirect3DViewport: IDirect3DViewport2;
        out lplpDirect3DViewport: IDirect3DViewport2; dwFlags: DWORD): HRESULT;
        stdcall;
    function EnumTextureFormats(lpd3dEnumTextureProc:
        LPD3DENUMTEXTUREFORMATSCALLBACK; lpArg: Pointer): HRESULT; stdcall;
    function BeginScene: HRESULT; stdcall;
    function EndScene: HRESULT; stdcall;
    function GetDirect3D(out lpD3D: IDirect3D2): HRESULT; stdcall;
    (*** DrawPrimitive API ***)
    function SetCurrentViewport(lpd3dViewport2: IDirect3DViewport2): HRESULT;
        stdcall;
    function GetCurrentViewport(out lplpd3dViewport2: IDirect3DViewport2):
        HRESULT; stdcall;
    function SetRenderTarget(lpNewRenderTarget: IDirectDrawSurface): HRESULT;
        stdcall;
    function GetRenderTarget(out lplpNewRenderTarget: IDirectDrawSurface):
        HRESULT; stdcall;
    function Begin_(d3dpt: D3DPRIMITIVETYPE; d3dvt: D3DVERTEXTYPE;
        dwFlags: DWORD): HRESULT; stdcall;
    function BeginIndexed(dptPrimitiveType: D3DPRIMITIVETYPE; dvtVertexType:
        D3DVERTEXTYPE; const lpvVertices; dwNumVertices: DWORD;
        dwFlags: DWORD): HRESULT; stdcall;
    function Vertex(const lpVertexType): HRESULT; stdcall;
    function Index(wVertexIndex: WORD): HRESULT; stdcall;
    function End_(dwFlags: DWORD): HRESULT; stdcall;
    function GetRenderState(dwRenderStateType: D3DRENDERSTATETYPE;
        var lpdwRenderState: DWORD): HRESULT; stdcall;
    function SetRenderState(dwRenderStateType: D3DRENDERSTATETYPE;
        dwRenderState: DWORD): HRESULT; stdcall;
    function GetLightState(dwLightStateType: D3DLIGHTSTATETYPE;
        var lpdwLightState: DWORD): HRESULT; stdcall;
    function SetLightState(dwLightStateType: D3DLIGHTSTATETYPE;
        dwLightState: DWORD): HRESULT; stdcall;
    function SetTransform(dtstTransformStateType: D3DTRANSFORMSTATETYPE;
        const lpD3DMatrix: D3DMATRIX): HRESULT; stdcall;
    function GetTransform(dtstTransformStateType: D3DTRANSFORMSTATETYPE;
        var lpD3DMatrix: D3DMATRIX): HRESULT; stdcall;
    function MultiplyTransform(dtstTransformStateType: D3DTRANSFORMSTATETYPE;
        var lpD3DMatrix: D3DMATRIX): HRESULT; stdcall;
    function DrawPrimitive(dptPrimitiveType: D3DPRIMITIVETYPE;
        dvtVertexType: D3DVERTEXTYPE; const lpvVertices; dwVertexCount,
        dwFlags: DWORD): HRESULT; stdcall;
    function DrawIndexedPrimitive(dptPrimitiveType: D3DPRIMITIVETYPE;
        dvtVertexType: D3DVERTEXTYPE; const lpvVertices;
        dwVertexCount: DWORD; const dwIndices; dwIndexCount: DWORD;
        dwFlags: DWORD): HRESULT; stdcall;
    function SetClipStatus (const lpD3DClipStatus: D3DCLIPSTATUS): HRESULT;
        stdcall;
    function GetClipStatus (var lpD3DClipStatus: D3DCLIPSTATUS): HRESULT;
        stdcall;
  end;

(*
 * IDirect3DExecuteBuffer
 *)

  IDirect3DExecuteBuffer = interface(IUnknown)
    ['{4417C145-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DExecuteBuffer methods ***)
    function Initialize(lpDirect3DDevice: IDirect3DDevice;
        const lpDesc: D3DEXECUTEBUFFERDESC): HRESULT; stdcall;
    function Lock(var lpDesc: D3DEXECUTEBUFFERDESC): HRESULT; stdcall;
    function Unlock: HRESULT; stdcall;
    function SetExecuteData(const lpData: D3DEXECUTEDATA): HRESULT; stdcall;
    function GetExecuteData(var lpData: D3DEXECUTEDATA): HRESULT; stdcall;
    function Validate(var lpdwOffset: DWORD; lpFunc: LPD3DVALIDATECALLBACK;
        lpUserArg: Pointer; dwReserved: DWORD): HRESULT; stdcall;
    (*** Warning!  Optimize is defined differently in the header files
         and the online documentation ***)
    function Optimize(dwFlags: DWORD): HRESULT; stdcall;
  end;

(*
 * IDirect3DLight
 *)

  IDirect3DLight = interface(IUnknown)
    ['{4417C142-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DLight methods ***)
    function Initialize(lpDirect3D: IDirect3D): HRESULT; stdcall;
    function SetLight(const lpLight: D3DLIGHT): HRESULT; stdcall;
    function GetLight(var lpLight: D3DLIGHT): HRESULT; stdcall;
  end;

(*
 * IDirect3DMaterial
 *)

  IDirect3DMaterial = interface(IUnknown)
    ['{4417C144-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DMaterial methods ***)
    function Initialize(lpDirect3D: IDirect3D): HRESULT; stdcall;
    function SetMaterial(const lpMat: D3DMATERIAL): HRESULT; stdcall;
    function GetMaterial(var lpMat: D3DMATERIAL): HRESULT; stdcall;
    function GetHandle(lpDirect3DDevice: IDirect3DDevice;
        var lpHandle: D3DMATERIALHANDLE): HRESULT; stdcall;
    function Reserve: HRESULT; stdcall;
    function Unreserve: HRESULT; stdcall;
  end;

(*
 * IDirect3DMaterial2
 *)

  IDirect3DMaterial2 = interface(IUnknown)
    ['{93281503-8CF8-11D0-89AB-00A0C9054129}']
    (*** IDirect3DMaterial2 methods ***)
    function SetMaterial(const lpMat: D3DMATERIAL): HRESULT; stdcall;
    function GetMaterial(var lpMat: D3DMATERIAL): HRESULT; stdcall;
    function GetHandle(lpDirect3DDevice: IDirect3DDevice2;
        var lpHandle: D3DMATERIALHANDLE): HRESULT; stdcall;
  end;

(*
 * IDirect3DTexture
 *)

  IDirect3DTexture = interface(IUnknown)
    ['{2CDCD9E0-25A0-11CF-A31A-00AA00B93356}']
    (*** IDirect3DTexture methods ***)
    function Initialize(lpD3DDevice: IDirect3DDevice;
        lpDDSurface: IDirectDrawSurface): HRESULT; stdcall;
    function GetHandle(lpDirect3DDevice: IDirect3DDevice;
        var lpHandle: D3DTEXTUREHANDLE): HRESULT; stdcall;
    function PaletteChanged(dwStart: DWORD; dwCount: DWORD): HRESULT; stdcall;
    function Load(lpD3DTexture: IDirect3DTexture): HRESULT; stdcall;
    function Unload: HRESULT; stdcall;
  end;

(*
 * IDirect3DTexture2
 *)

  IDirect3DTexture2 = interface(IUnknown)
    ['{93281502-8CF8-11D0-89AB-00A0C9054129}']
    (*** IDirect3DTexture2 methods ***)
    function GetHandle(lpDirect3DDevice2: IDirect3DDevice2;
        var lpHandle: D3DTEXTUREHANDLE): HRESULT; stdcall;
    function PaletteChanged(dwStart: DWORD; dwCount: DWORD): HRESULT; stdcall;
    function Load(lpD3DTexture2: IDirect3DTexture2): HRESULT; stdcall;
  end;

(*
 * IDirect3DViewport
 *)

  IDirect3DViewport = interface(IUnknown)
    ['{4417C146-33AD-11CF-816F-0000C020156E}']
    (*** IDirect3DViewport methods ***)
    function Initialize(lpDirect3D: IDirect3D): HRESULT; stdcall;
    function GetViewport(var lpData: D3DVIEWPORT): HRESULT; stdcall;
    function SetViewport(const lpData: D3DVIEWPORT): HRESULT; stdcall;
    function TransformVertices(dwVertexCount: DWORD;
        var lpData: D3DTRANSFORMDATA; dwFlags: DWORD;
        var lpOffscreen: DWORD): HRESULT; stdcall;
    function LightElements(dwElementCount: DWORD;
        var lpData: D3DLIGHTDATA): HRESULT; stdcall;
    function SetBackground(hMat: D3DMATERIALHANDLE): HRESULT; stdcall;
    function GetBackground(hMat: D3DMATERIALHANDLE): HRESULT; stdcall;
    function SetBackgroundDepth(lpDDSurface: IDirectDrawSurface): HRESULT;
        stdcall;
    function GetBackgroundDepth(out lplpDDSurface: IDirectDrawSurface;
        var lpValid: BOOL): HRESULT; stdcall;
    function Clear(dwCount: DWORD; const lpRects: D3DRECT; dwFlags: DWORD):
        HRESULT; stdcall;
    function AddLight(lpDirect3DLight: IDirect3DLight): HRESULT; stdcall;
    function DeleteLight(lpDirect3DLight: IDirect3DLight): HRESULT; stdcall;
    function NextLight(lpDirect3DLight: IDirect3DLight;
        out lplpDirect3DLight: IDirect3DLight; dwFlags: DWORD): HRESULT;
        stdcall;
  end;

(*
 * IDirect3DViewport2
 *)

  IDirect3DViewport2 = interface(IUnknown)
    ['{93281500-8CF8-11D0-89AB-00A0C9054129}']
    (*** IDirect3DViewport2 methods ***)
    function Initialize(lpDirect3D: IDirect3D): HRESULT; stdcall;
    function GetViewport(var lpData: D3DVIEWPORT): HRESULT; stdcall;
    function SetViewport(const lpData: D3DVIEWPORT): HRESULT; stdcall;
    function TransformVertices(dwVertexCount: DWORD;
        var lpData: D3DTRANSFORMDATA; dwFlags: DWORD;
        var lpOffscreen: DWORD): HRESULT; stdcall;
    function LightElements(dwElementCount: DWORD;
        var lpData: D3DLIGHTDATA): HRESULT; stdcall;
    function SetBackground(hMat: D3DMATERIALHANDLE): HRESULT; stdcall;
    function GetBackground(hMat: D3DMATERIALHANDLE): HRESULT; stdcall;
    function SetBackgroundDepth(lpDDSurface: IDirectDrawSurface): HRESULT;
        stdcall;
    function GetBackgroundDepth(out lplpDDSurface: IDirectDrawSurface;
        var lpValid: BOOL): HRESULT; stdcall;
    function Clear(dwCount: DWORD; const lpRects: D3DRECT; dwFlags: DWORD):
        HRESULT; stdcall;
    function AddLight(lpDirect3DLight: IDirect3DLight): HRESULT; stdcall;
    function DeleteLight(lpDirect3DLight: IDirect3DLight): HRESULT; stdcall;
    function NextLight(lpDirect3DLight: IDirect3DLight;
        out lplpDirect3DLight: IDirect3DLight; dwFlags: DWORD): HRESULT;
        stdcall;
    (*** IDirect3DViewport2 methods ***)
    function GetViewport2(var lpData: D3DVIEWPORT2): HRESULT; stdcall;
    function SetViewport2(const lpData: D3DVIEWPORT2): HRESULT; stdcall;
  end;

const

(****************************************************************************
 *
 * Flags for IDirect3DDevice::NextViewport
 *
 ****************************************************************************)

(*
 * Return the next viewport
 *)
  D3DNEXT_NEXT =	$00000001;

(*
 * Return the first viewport
 *)
  D3DNEXT_HEAD =	$00000002;

(*
 * Return the last viewport
 *)
  D3DNEXT_TAIL =	$00000004;


(****************************************************************************
 *
 * Flags for DrawPrimitive/DrawIndexedPrimitive
 *   Also valid for Begin/BeginIndexed
 *
 ****************************************************************************)

(*
 * Wait until the device is ready to draw the primitive
 * This will cause DP to not return DDERR_WASSTILLDRAWING
 *)
  D3DDP_WAIT = $00000001;


(*
 * Hint that the primitives have been clipped by the application.
 *)
  D3DDP_DONOTCLIP = $00000004;

(*
 * Hint that the extents need not be updated.
 *)
  D3DDP_DONOTUPDATEEXTENTS = $00000008;


(*
 * Direct3D Errors
 * DirectDraw error codes are used when errors not specified here.
 *)

const
  D3D_OK                          = DD_OK;
  D3DERR_BADMAJORVERSION          = $88760000 + 700;
  D3DERR_BADMINORVERSION          = $88760000 + 701;

(*
 * An invalid device was requested by the application.
 *)
  D3DERR_INVALID_DEVICE   = $88760000 + 705;
  D3DERR_INITFAILED       = $88760000 + 706;

(*
 * SetRenderTarget attempted on a device that was
 * QI'd off the render target.
 *)
  D3DERR_DEVICEAGGREGATED = $88760000 + 707;

  D3DERR_EXECUTE_CREATE_FAILED    = $88760000 + 710;
  D3DERR_EXECUTE_DESTROY_FAILED   = $88760000 + 711;
  D3DERR_EXECUTE_LOCK_FAILED      = $88760000 + 712;
  D3DERR_EXECUTE_UNLOCK_FAILED    = $88760000 + 713;
  D3DERR_EXECUTE_LOCKED           = $88760000 + 714;
  D3DERR_EXECUTE_NOT_LOCKED       = $88760000 + 715;

  D3DERR_EXECUTE_FAILED           = $88760000 + 716;
  D3DERR_EXECUTE_CLIPPED_FAILED   = $88760000 + 717;

  D3DERR_TEXTURE_NO_SUPPORT       = $88760000 + 720;
  D3DERR_TEXTURE_CREATE_FAILED    = $88760000 + 721;
  D3DERR_TEXTURE_DESTROY_FAILED   = $88760000 + 722;
  D3DERR_TEXTURE_LOCK_FAILED      = $88760000 + 723;
  D3DERR_TEXTURE_UNLOCK_FAILED    = $88760000 + 724;
  D3DERR_TEXTURE_LOAD_FAILED      = $88760000 + 725;
  D3DERR_TEXTURE_SWAP_FAILED      = $88760000 + 726;
  D3DERR_TEXTURE_LOCKED           = $88760000 + 727;
  D3DERR_TEXTURE_NOT_LOCKED       = $88760000 + 728;
  D3DERR_TEXTURE_GETSURF_FAILED   = $88760000 + 729;

  D3DERR_MATRIX_CREATE_FAILED     = $88760000 + 730;
  D3DERR_MATRIX_DESTROY_FAILED    = $88760000 + 731;
  D3DERR_MATRIX_SETDATA_FAILED    = $88760000 + 732;
  D3DERR_MATRIX_GETDATA_FAILED    = $88760000 + 733;
  D3DERR_SETVIEWPORTDATA_FAILED   = $88760000 + 734;

  D3DERR_INVALIDCURRENTVIEWPORT   = $88760000 + 735;
  D3DERR_INVALIDPRIMITIVETYPE     = $88760000 + 736;
  D3DERR_INVALIDVERTEXTYPE        = $88760000 + 737;
  D3DERR_TEXTURE_BADSIZE          = $88760000 + 738;
  D3DERR_INVALIDRAMPTEXTURE	  = $88760000 + 739;

  D3DERR_MATERIAL_CREATE_FAILED   = $88760000 + 740;
  D3DERR_MATERIAL_DESTROY_FAILED  = $88760000 + 741;
  D3DERR_MATERIAL_SETDATA_FAILED  = $88760000 + 742;
  D3DERR_MATERIAL_GETDATA_FAILED  = $88760000 + 743;
  D3DERR_INVALIDPALETTE	          = $88760000 + 744;

  D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY = $88760000 + 745;
  D3DERR_ZBUFF_NEEDS_VIDEOMEMORY  = $88760000 + 746;
  D3DERR_SURFACENOTINVIDMEM       = $88760000 + 747;

  D3DERR_LIGHT_SET_FAILED         = $88760000 + 750;
  D3DERR_LIGHTHASVIEWPORT	  = $88760000 + 751;
  D3DERR_LIGHTNOTINTHISVIEWPORT   = $88760000 + 752;

  D3DERR_SCENE_IN_SCENE           = $88760000 + 760;
  D3DERR_SCENE_NOT_IN_SCENE       = $88760000 + 761;
  D3DERR_SCENE_BEGIN_FAILED       = $88760000 + 762;
  D3DERR_SCENE_END_FAILED         = $88760000 + 763;

  D3DERR_INBEGIN                  = $88760000 + 770;
  D3DERR_NOTINBEGIN               = $88760000 + 771;
  D3DERR_NOVIEWPORTS              = $88760000 + 772;
  D3DERR_VIEWPORTDATANOTSET       = $88760000 + 773;
  D3DERR_VIEWPORTHASNODEVICE      = $88760000 + 774;
  D3DERR_NOCURRENTVIEWPORT        = $88760000 + 775;

procedure DisableFPUExceptions;
procedure EnableFPUExceptions;

implementation

procedure DisableFPUExceptions;
var
  FPUControlWord: WORD;
asm
  FSTCW   FPUControlWord;
  OR      FPUControlWord, $4 + $1; { Divide by zero + invalid operation }
  FLDCW   FPUControlWord;
end;

procedure EnableFPUExceptions;
var
  FPUControlWord: WORD;
asm
  FSTCW   FPUControlWord;
  AND     FPUControlWord, $FFFF - $4 - $1; { Divide by zero + invalid operation }
  FLDCW   FPUControlWord;
end;

initialization
  DisableFPUExceptions;
end.
