
(*==========================================================================;
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:	d3drm.h
 *  Content:	Direct3DRM include file
 *
 ***************************************************************************)

unit D3DRM;

interface

{$Z4}
{$A+}

uses Windows, DDraw, D3D, D3DTypes, D3DRMObj, D3DRMDef;

const
  IID_IDirect3DRM: TGUID = ( D1:$2bc49361;D2:$8327;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRM2: TGUID = ( D1:$4516ecc8;D2:$8f20;D3:$11d0;D4:($9b,$6d,$00,$00,$c0,$78,$1b,$c3));

type
  IDirect3DRM = interface(IUnknown)
    ['{2BC49361-8327-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRM methods ***)
    function CreateObject(const rclsid: TGUID; pUnkOuter: IUnknown;
        const riid: TGUID; out ppv): HRESULT; stdcall;
    function CreateFrame(lpD3DRMFrame: IDirect3DRMFrame;
        out lplpD3DRMFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function CreateMesh(out lplpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    function CreateMeshBuilder(out lplpD3DRMMeshBuilder:
        IDirect3DRMMeshBuilder): HRESULT; stdcall;
    function CreateFace(out lplpd3drmFace: IDirect3DRMFace): HRESULT; stdcall;
    function CreateAnimation(out lplpD3DRMAnimation: IDirect3DRMAnimation):
        HRESULT; stdcall;
    function CreateAnimationSet(out lplpD3DRMAnimationSet:
        IDirect3DRMAnimationSet): HRESULT; stdcall;
    function CreateTexture(const lpImage: D3DRMIMAGE;
        out lplpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function CreateLight(d3drmltLightType: D3DRMLIGHTTYPE;
        cColor: D3DCOLOR; out lplpD3DRMLight: IDirect3DRMLight): HRESULT;
        stdcall;
    function CreateLightRGB(ltLightType: D3DRMLIGHTTYPE; vRed, vGreen, vBlue:
        D3DVALUE; out lplpD3DRMLight: IDirect3DRMLight): HRESULT; stdcall;
    function CreateMaterial(vPower: D3DVALUE; out lplpD3DRMMaterial:
        IDirect3DRMMaterial): HRESULT; stdcall;
    function CreateDevice(dwWidth, dwHeight: DWORD; out lplpD3DRMDevice:
        IDirect3DRMDevice): HRESULT; stdcall;
    function CreateDeviceFromSurface(const lpGUID: TGUID; lpDD: IDirectDraw;
        lpDDSBack: IDirectDrawSurface; out lplpD3DRMDevice: IDirect3DRMDevice):
        HRESULT; stdcall;
    function CreateDeviceFromD3D(lpD3D: IDirect3D; lpD3DDev: IDirect3DDevice;
        out lplpD3DRMDevice: IDirect3DRMDevice): HRESULT; stdcall;
    function CreateDeviceFromClipper(lpDDClipper: IDirectDrawClipper;
        const lpGUID: TGUID; width, height: Integer; out lplpD3DRMDevice:
        IDirect3DRMDevice): HRESULT; stdcall;
    function CreateTextureFromSurface(lpDDS: IDirectDrawSurface;
        out lplpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function CreateShadow(lpVisual: IDirect3DRMVisual;
        lpLight: IDirect3DRMLight; px, py, pz, nx, ny, nz: D3DVALUE;
        out lplpShadow: IDirect3DRMVisual): HRESULT; stdcall;
    function CreateViewport(lpDev: IDirect3DRMDevice;
        lpCamera: IDirect3DRMFrame; dwXPos, dwYPos, dwWidth, dwHeight: DWORD;
        out lplpD3DRMViewport: IDirect3DRMViewport): HRESULT; stdcall;
    function CreateWrap(wraptype: D3DRMWRAPTYPE; lpRef: IDirect3DRMFrame;
        ox, oy, oz, dx, dy, dz, ux, uy, uz, ou, ov, su, sv: D3DVALUE;
        out lplpD3DRMWrap: IDirect3DRMWrap): HRESULT; stdcall;
    function CreateUserVisual(fn: D3DRMUSERVISUALCALLBACK; lpArg: Pointer;
        out lplpD3DRMUV: IDirect3DRMUserVisual): HRESULT; stdcall;
    function LoadTexture(lpFileName: LPSTR; out lplpD3DRMTexture:
        IDirect3DRMTexture): HRESULT; stdcall;
    function LoadTextureFromResource(rs: HRSRC; out lplpD3DRMTexture:
        IDirect3DRMTexture): HRESULT; stdcall;
    function SetSearchPath(lpPath: LPSTR): HRESULT; stdcall;
    function AddSearchPath(lpPath: LPSTR): HRESULT; stdcall;
    function GetSearchPath(var lpdwSize: DWORD; lpszPath: LPSTR): HRESULT;
         stdcall;
    function SetDefaultTextureColors(dwColors: DWORD): HRESULT; stdcall;
    function SetDefaultTextureShades(dwShades: DWORD): HRESULT; stdcall;
    function GetDevices(out lplpDevArray: IDirect3DRMDeviceArray): HRESULT;
         stdcall;
    function GetNamedObject(lpName: LPSTR; out lplpD3DRMObject:
        IDirect3DRMObject): HRESULT; stdcall;
    function EnumerateObjects(func: D3DRMOBJECTCALLBACK; lpArg: Pointer):
        HRESULT; stdcall;
    function Load(lpvObjSource, lpvObjID: Pointer; var lplpGUIDs: PGUID;
        dwcGUIDs: DWORD; d3drmLOFlags: D3DRMLOADOPTIONS; d3drmLoadProc:
        D3DRMLOADCALLBACK; lpArgLP: Pointer; d3drmLoadTextureProc:
        D3DRMLOADTEXTURECALLBACK; lpArgLTP: Pointer;
        lpParentFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function Tick(d3dvalTick: D3DVALUE): HRESULT; stdcall;
  end;

type
  IDirect3DRM2 = interface(IUnknown)
    ['{4516ECC8-8F20-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRM2 methods ***)
    function CreateObject(const rclsid: TGUID; pUnkOuter: IUnknown;
        const riid: TGUID; out ppv): HRESULT; stdcall;
    function CreateFrame(lpD3DRMFrame: IDirect3DRMFrame;
        out lplpD3DRMFrame: IDirect3DRMFrame2): HRESULT; stdcall;
    function CreateMesh(out lplpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    function CreateMeshBuilder(out lplpD3DRMMeshBuilder:
        IDirect3DRMMeshBuilder2): HRESULT; stdcall;
    function CreateFace(out lplpd3drmFace: IDirect3DRMFace): HRESULT; stdcall;
    function CreateAnimation(out lplpD3DRMAnimation: IDirect3DRMAnimation):
        HRESULT; stdcall;
    function CreateAnimationSet(out lplpD3DRMAnimationSet:
        IDirect3DRMAnimationSet): HRESULT; stdcall;
    function CreateTexture(const lpImage: D3DRMIMAGE;
        out lplpD3DRMTexture: IDirect3DRMTexture2): HRESULT; stdcall;
    function CreateLight(d3drmltLightType: D3DRMLIGHTTYPE;
        cColor: D3DCOLOR; out lplpD3DRMLight: IDirect3DRMLight): HRESULT;
        stdcall;
    function CreateLightRGB(ltLightType: D3DRMLIGHTTYPE; vRed,
        vGreen, vBlue: D3DVALUE; out lplpD3DRMLight: IDirect3DRMLight):
        HRESULT; stdcall;
    function CreateMaterial(vPower: D3DVALUE; out lplpD3DRMMaterial:
        IDirect3DRMMaterial): HRESULT; stdcall;
    function CreateDevice(dwWidth, dwHeight: DWORD; out lplpD3DRMDevice:
        IDirect3DRMDevice2): HRESULT; stdcall;
    function CreateDeviceFromSurface(const lpGUID: TGUID; lpDD: IDirectDraw;
        lpDDSBack: IDirectDrawSurface; out lplpD3DRMDevice: IDirect3DRMDevice2):
        HRESULT; stdcall;
    function CreateDeviceFromD3D(lpD3D: IDirect3D; lpD3DDev: IDirect3DDevice;
        out lplpD3DRMDevice: IDirect3DRMDevice2): HRESULT; stdcall;
    function CreateDeviceFromClipper(lpDDClipper: IDirectDrawClipper;
        const lpGUID: TGUID; width, height: Integer; out lplpD3DRMDevice:
        IDirect3DRMDevice2): HRESULT; stdcall;
    function CreateTextureFromSurface( lpDDS: IDirectDrawSurface;
        out lplpD3DRMTexture: IDirect3DRMTexture2): HRESULT; stdcall;
    function CreateShadow(lpVisual: IDirect3DRMVisual;
        lpLight: IDirect3DRMLight; px, py, pz, nx, ny, nz: D3DVALUE;
        out lplpShadow: IDirect3DRMVisual): HRESULT; stdcall;
    function CreateViewport(lpDev: IDirect3DRMDevice;
        lpCamera: IDirect3DRMFrame; dwXPos, dwYPos, dwWidth, dwHeight: DWORD;
        out lplpD3DRMViewport: IDirect3DRMViewport): HRESULT; stdcall;
    function CreateWrap(wraptype: D3DRMWRAPTYPE; lpRef: IDirect3DRMFrame;
        ox, oy, oz, dx, dy, dz, ux, uy, uz, ou, ov, su, sv: D3DVALUE;
        out lplpD3DRMWrap: IDirect3DRMWrap): HRESULT; stdcall;
    function CreateUserVisual(fn: D3DRMUSERVISUALCALLBACK; lpArg: Pointer;
        out lplpD3DRMUV: IDirect3DRMUserVisual): HRESULT; stdcall;
    function LoadTexture(lpFileName: LPSTR; out lplpD3DRMTexture:
        IDirect3DRMTexture2): HRESULT; stdcall;
    function LoadTextureFromResource(rs: HRSRC; out lplpD3DRMTexture:
        IDirect3DRMTexture2): HRESULT; stdcall;
    function SetSearchPath(lpPath: LPSTR): HRESULT; stdcall;
    function AddSearchPath(lpPath: LPSTR): HRESULT; stdcall;
    function GetSearchPath(var lpdwSize: DWORD; lpszPath: LPSTR): HRESULT;
         stdcall;
    function SetDefaultTextureColors(dwColors: DWORD): HRESULT; stdcall;
    function SetDefaultTextureShades(dwShades: DWORD): HRESULT; stdcall;
    function GetDevices(out lplpDevArray: IDirect3DRMDeviceArray): HRESULT;
         stdcall;
    function GetNamedObject(lpName: LPSTR; out lplpD3DRMObject:
        IDirect3DRMObject): HRESULT; stdcall;
    function EnumerateObjects(func: D3DRMOBJECTCALLBACK; lpArg: Pointer):
        HRESULT; stdcall;
    function Load(lpvObjSource, lpvObjID: Pointer; var lplpGUIDs: PGUID;
        dwcGUIDs: DWORD; d3drmLOFlags: D3DRMLOADOPTIONS; d3drmLoadProc:
        D3DRMLOADCALLBACK; lpArgLP: Pointer; d3drmLoadTextureProc:
        D3DRMLOADTEXTURECALLBACK; lpArgLTP: Pointer; lpParentFrame:
        IDirect3DRMFrame): HRESULT; stdcall;
    function Tick(d3dvalTick: D3DVALUE): HRESULT; stdcall;
    function CreateProgressiveMesh(out lplpD3DRMProgressiveMesh:
        IDirect3DRMProgressiveMesh): HRESULT; stdcall;
  end;

const
  D3DRM_OK                        = DD_OK;
  D3DRMERR_BADOBJECT              = $88760000 + 781;
  D3DRMERR_BADTYPE                = $88760000 + 782;
  D3DRMERR_BADALLOC               = $88760000 + 783;
  D3DRMERR_FACEUSED               = $88760000 + 784;
  D3DRMERR_NOTFOUND               = $88760000 + 785;
  D3DRMERR_NOTDONEYET             = $88760000 + 786;
  D3DRMERR_FILENOTFOUND           = $88760000 + 787;
  D3DRMERR_BADFILE                = $88760000 + 788;
  D3DRMERR_BADDEVICE              = $88760000 + 789;
  D3DRMERR_BADVALUE               = $88760000 + 790;
  D3DRMERR_BADMAJORVERSION        = $88760000 + 791;
  D3DRMERR_BADMINORVERSION        = $88760000 + 792;
  D3DRMERR_UNABLETOEXECUTE        = $88760000 + 793;
  D3DRMERR_LIBRARYNOTFOUND        = $88760000 + 794;
  D3DRMERR_INVALIDLIBRARY         = $88760000 + 795;
  D3DRMERR_PENDING                = $88760000 + 796;
  D3DRMERR_NOTENOUGHDATA          = $88760000 + 797;
  D3DRMERR_REQUESTTOOLARGE        = $88760000 + 798;
  D3DRMERR_REQUESTTOOSMALL        = $88760000 + 799;
  D3DRMERR_CONNECTIONLOST         = $88760000 + 800;
  D3DRMERR_LOADABORTED            = $88760000 + 801;
  D3DRMERR_NOINTERNET             = $88760000 + 802;
  D3DRMERR_BADCACHEFILE           = $88760000 + 803;
  D3DRMERR_BOXNOTSET	          = $88760000 + 804;
  D3DRMERR_BADPMDATA              = $88760000 + 805;

(* Create a Direct3DRM API *)
function Direct3DRMCreate(out lplpDirect3DRM: IDirect3DRM): HRESULT; stdcall;

implementation

function Direct3DRMCreate; external 'D3DRM.DLL';

end.

