
(*==========================================================================;
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:	d3drm.h
 *  Content:	Direct3DRM include file
 *
 ***************************************************************************)

unit D3DRMObj;

interface

{$Z4}
{$A+}

uses Windows, D3D, D3DTypes, DDraw, D3DRMDef;

(*
 * Direct3DRM Object classes
 *)

const
  CLSID_CDirect3DRMDevice: TGUID =(D1:$4fa3568e;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMViewport: TGUID =(D1:$4fa3568f;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMFrame: TGUID =(D1:$4fa35690;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMMesh: TGUID =(D1:$4fa35691;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMMeshBuilder: TGUID =(D1:$4fa35692;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMFace: TGUID =(D1:$4fa35693;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMLight: TGUID =(D1:$4fa35694;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMTexture: TGUID =(D1:$4fa35695;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMWrap: TGUID =(D1:$4fa35696;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMMaterial: TGUID =(D1:$4fa35697;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMAnimation: TGUID =(D1:$4fa35698;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMAnimationSet: TGUID =(D1:$4fa35699;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMUserVisual: TGUID =(D1:$4fa3569a;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMShadow: TGUID =(D1:$4fa3569b;D2:$623f;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  CLSID_CDirect3DRMViewportInterpolator: TGUID =(D1:$de9eaa1;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMFrameInterpolator: TGUID =(D1:$de9eaa2;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMMeshInterpolator: TGUID =(D1:$de9eaa3;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMLightInterpolator: TGUID =(D1:$de9eaa6;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMMaterialInterpolator: TGUID =(D1:$de9eaa7;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMTextureInterpolator: TGUID =(D1:$de9eaa8;D2:$3b84;D3:$11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  CLSID_CDirect3DRMProgressiveMesh: TGUID =(D1:$4516ec40;D2:$8f20;D3:$11d0;D4:($9b, $6d, $00, $00, $c0, $78, $1b, $c3));

(*
 * Direct3DRM Object interfaces
 *)

  IID_IDirect3DRMObject: TGUID =(D1:$eb16cb00;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMDevice: TGUID =(D1:$e9e19280;D2:$6e05;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMDevice2: TGUID = (D1:$4516ec78;D2: $8f20;D3: $11d0;D4:($9b, $6d, $00, $00, $c0, $78, $1b, $c3));
  IID_IDirect3DRMViewport: TGUID =(D1:$eb16cb02;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMFrame: TGUID =(D1:$eb16cb03;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMFrame2: TGUID = (D1:$c3dfbd60;D2: $3988;D3: $11d0;D4:($9e, $c2, $0, $0, $c0, $29, $1a, $c3));
  IID_IDirect3DRMVisual: TGUID =(D1:$eb16cb04;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMMesh: TGUID =(D1:$a3a80d01;D2:$6e12;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMMeshBuilder: TGUID =(D1:$a3a80d02;D2:$6e12;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMMeshBuilder2: TGUID = (D1:$4516ec77;D2: $8f20;D3: $11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  IID_IDirect3DRMFace: TGUID =(D1:$eb16cb07;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMLight: TGUID =(D1:$eb16cb08;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMTexture: TGUID =(D1:$eb16cb09;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMTexture2: TGUID = (D1:$120f30c0;D2: $1629;D3: $11d0;D4:($94, $1c, $0, $80, $c8, $c, $fa, $7b));
  IID_IDirect3DRMWrap: TGUID =(D1:$eb16cb0a;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMMaterial: TGUID =(D1:$eb16cb0b;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMAnimation: TGUID =(D1:$eb16cb0d;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMAnimationSet: TGUID =(D1:$eb16cb0e;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMDeviceArray: TGUID =(D1:$eb16cb10;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMViewportArray: TGUID =(D1:$eb16cb11;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMFrameArray: TGUID =(D1:$eb16cb12;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMVisualArray: TGUID =(D1:$eb16cb13;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMLightArray: TGUID =(D1:$eb16cb14;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMPickedArray: TGUID =(D1:$eb16cb16;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMFaceArray: TGUID =(D1:$eb16cb17;D2:$d271;D3:$11ce;D4:($ac,$48,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMUserVisual: TGUID =(D1:$59163de0;D2:$6d43;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMShadow: TGUID =(D1:$af359780;D2:$6ba3;D3:$11cf;D4:($ac,$4a,$0,$0,$c0,$38,$25,$a1));
  IID_IDirect3DRMInterpolator: TGUID = (D1:$242f6bc1;D2: $3849;D3: $11d0;D4:($9b, $6d, $0, $0, $c0, $78, $1b, $c3));
  IID_IDirect3DRMProgressiveMesh: TGUID = (D1:$4516ec79;D2: $8f20;D3: $11d0;D4:($9b, $6d, $00, $00, $c0, $78, $1b, $c3));
  IID_IDirect3DRMPicked2Array: TGUID = (D1:$4516ec7b;D2: $8f20;D3: $11d0;D4:($9b, $6d, $00, $00, $c0, $78, $1b, $c3));

type
  IDirect3DRMObject = interface;
  IDirect3DRMDevice = interface;
  IDirect3DRMDevice2 = interface;
  IDirect3DRMViewport = interface;
  IDirect3DRMFrame = interface;
  IDirect3DRMFrame2 = interface;
  IDirect3DRMVisual = interface;
  IDirect3DRMMesh = interface;
  IDirect3DRMMeshBuilder = interface;
  IDirect3DRMMeshBuilder2 = interface;
  IDirect3DRMFace = interface;
  IDirect3DRMLight = interface;
  IDirect3DRMTexture = interface;
  IDirect3DRMTexture2 = interface;
  IDirect3DRMWrap = interface;
  IDirect3DRMMaterial = interface;
  IDirect3DRMInterpolator = interface;
  IDirect3DRMAnimation = interface;
  IDirect3DRMAnimationSet = interface;
  IDirect3DRMUserVisual = interface;
  IDirect3DRMShadow = interface;
  IDirect3DRMArray = interface;
  IDirect3DRMObjectArray = interface;
  IDirect3DRMDeviceArray = interface;
  IDirect3DRMFaceArray = interface;
  IDirect3DRMViewportArray = interface;
  IDirect3DRMFrameArray = interface;
  IDirect3DRMVisualArray = interface;
  IDirect3DRMPickedArray = interface;
  IDirect3DRMPicked2Array = interface;
  IDirect3DRMLightArray = interface;
  IDirect3DRMProgressiveMesh = interface;


  D3DRMOBJECTCALLBACK = procedure(lpD3DRMobj: IDirect3DRMObject;
      lpArg: Pointer); CDECL;

  D3DRMFRAMEMOVECALLBACK = procedure(lpD3DRMFrame: IDirect3DRMFrame;
      lpArg: Pointer; delta: D3DVALUE); CDECL;

  D3DRMUPDATECALLBACK = procedure(lpobj: IDirect3DRMDevice; lpArg: Pointer;
      iRectCount: Integer; d3dRectUpdate: LPD3DRECT); CDECL;

  D3DRMUSERVISUALCALLBACK = function(lpD3DRMUV: IDirect3DRMUserVisual;
      lpArg: Pointer; lpD3DRMUVreason: D3DRMUSERVISUALREASON;
      lpD3DRMDev: IDirect3DRMDevice;
      lpD3DRMview: IDirect3DRMViewport): Integer; CDECL;

  D3DRMLOADTEXTURECALLBACK = function(tex_name: PChar; lpArg: Pointer;
      lpD3DRMTex: IDirect3DRMTexture): HRESULT; CDECL;

  D3DRMLOADCALLBACK = procedure(lpObject: IDirect3DRMObject; const ObjectGuid: TGUID;
     lpArg: Pointer); CDECL;

  D3DRMPICKDESC = record
    ulFaceIdx: Longint;
    lGroupIdx: Longint;
    vPosition: D3DVECTOR;
  end;
  LPD3DRMPICKDESC = ^D3DRMPICKDESC;

  D3DRMPICKDESC2 = record
    ulFaceIdx: Longint;
    lGroupIdx: Longint;
    dvPosition: D3DVECTOR;
    tu, tv: D3DVALUE;
    dvNormal: D3DVECTOR;
    dcColor: D3DCOLOR;
  end;
  LPD3DRMPICKDESC2 = ^D3DRMPICKDESC2;

(*
 * Base interface
 *)
  IDirect3DRMObject = interface(IUnknown)
    ['{EB16CB00-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMObject methods ***)
    function Clone(pUnkOuter: IUnknown; const riid: TGUID;
        out ppvObj): HRESULT; stdcall;
    function AddDestroyCallback(lpCallback: D3DRMOBJECTCALLBACK;
        lpArg: Pointer): HRESULT; stdcall;
    function DeleteDestroyCallback(d3drmObjProc: D3DRMOBJECTCALLBACK;
        lpArg: Pointer): HRESULT; stdcall;
    function SetAppData(ulData: DWORD): HRESULT; stdcall;
    function GetAppData: DWORD; stdcall;
    function SetName(lpName: PChar): HRESULT; stdcall;
    function GetName(var lpdwSize: DWORD; lpName: PChar): HRESULT; stdcall;
    function GetClassName(var lpdwSize: DWORD; lpName: PChar): HRESULT; stdcall;
  end;

  IDirect3DRMVisual = interface(IDirect3DRMObject)
    ['{EB16CB04-D271-11CE-AC48-0000C03825A1}']
  end;

  IDirect3DRMDevice = interface(IDirect3DRMObject)
    ['{E9E19280-6E05-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRMDevice methods ***)
    function Init(width: Longint; height: Longint): HRESULT; stdcall;
    function InitFromD3D(lpD3D: IDirect3D; lpD3DIMDev: IDirect3DDevice):
        HRESULT; stdcall;
    function InitFromClipper(lpDDClipper: IDirectDrawClipper;
        const lpGUID: TGUID; width: Integer; height: Integer): HRESULT; stdcall;
    function Update: HRESULT; stdcall;
    function AddUpdateCallback(d3drmUpdateProc: D3DRMUPDATECALLBACK;
        arg: Pointer): HRESULT; stdcall;
    function DeleteUpdateCallback(d3drmUpdateProc: D3DRMUPDATECALLBACK;
        arg: Pointer): HRESULT; stdcall;
    function SetBufferCount(dwCount: DWORD): HRESULT; stdcall;
    function GetBufferCount: DWORD; stdcall;
    function SetDither(bDither: BOOL): HRESULT; stdcall;
    function SetShades(ulShades: DWORD): HRESULT; stdcall;
    function SetQuality(rqQuality: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function SetTextureQuality(tqTextureQuality: D3DRMTEXTUREQUALITY): HRESULT;
        stdcall;
    function GetViewports(out lplpViewports: IDirect3DRMViewportArray): HRESULT;
        stdcall;
    function GetDither: BOOL; stdcall;
    function GetShades: DWORD; stdcall;
    function GetHeight: DWORD; stdcall;
    function GetWidth: DWORD; stdcall;
    function GetTrianglesDrawn: DWORD; stdcall;
    function GetWireframeOptions: DWORD; stdcall;
    function GetQuality: D3DRMRENDERQUALITY; stdcall;
    function GetColorModel: D3DCOLORMODEL; stdcall;
    function GetTextureQuality: D3DRMTEXTUREQUALITY; stdcall;
    function GetDirect3DDevice(out lplpD3DDevice: IDirect3DDevice): HRESULT;
        stdcall;
  end;

  IDirect3DRMDevice2 = interface(IDirect3DRMObject)
    ['{4516EC78-8F20-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRMDevice methods ***)
    function Init(width: Longint; height: Longint): HRESULT; stdcall;
    function InitFromD3D(lpD3D: IDirect3D; lpD3DIMDev: IDirect3DDevice):
        HRESULT; stdcall;
    function InitFromClipper(lpDDClipper: IDirectDrawClipper;
        const lpGUID: TGUID; width: Integer; height: Integer): HRESULT; stdcall;
    function Update: HRESULT; stdcall;
    function AddUpdateCallback(d3drmUpdateProc: D3DRMUPDATECALLBACK;
        arg: Pointer): HRESULT; stdcall;
    function DeleteUpdateCallback(d3drmUpdateProc: D3DRMUPDATECALLBACK;
        arg: Pointer): HRESULT; stdcall;
    function SetBufferCount(dwCount: DWORD): HRESULT; stdcall;
    function GetBufferCount: DWORD; stdcall;
    function SetDither(bDither: BOOL): HRESULT; stdcall;
    function SetShades(ulShades: DWORD): HRESULT; stdcall;
    function SetQuality(rqQuality: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function SetTextureQuality(tqTextureQuality: D3DRMTEXTUREQUALITY): HRESULT;
        stdcall;
    function GetViewports(out lplpViewports: IDirect3DRMViewportArray): HRESULT;
        stdcall;
    function GetDither: BOOL; stdcall;
    function GetShades: DWORD; stdcall;
    function GetHeight: DWORD; stdcall;
    function GetWidth: DWORD; stdcall;
    function GetTrianglesDrawn: DWORD; stdcall;
    function GetWireframeOptions: DWORD; stdcall;
    function GetQuality: D3DRMRENDERQUALITY; stdcall;
    function GetColorModel: D3DCOLORMODEL; stdcall;
    function GetTextureQuality: D3DRMTEXTUREQUALITY; stdcall;
    function GetDirect3DDevice(out lplpD3DDevice: IDirect3DDevice): HRESULT;
        stdcall;
    (*** IDirect3DRMDevice2 methods ***)
    function InitFromD3D2(lpD3D: IDirect3D2; lpD3DIMDev: IDirect3DDevice2):
        HRESULT; stdcall;
    function InitFromSurface(const lpGUID: TGUID; lpDD: IDirectDraw;
	lpDDSBack: IDirectDrawSurface): HRESULT; stdcall;
    function SetRenderMode(dwFlags: DWORD): HRESULT; stdcall;
    function GetRenderMode: DWORD; stdcall;
    function GetDirect3DDevice2(out lplpD3DDevice: IDirect3DDevice2): HRESULT;
        stdcall;
  end;

  IDirect3DRMViewport = interface(IDirect3DRMObject)
    ['{EB16CB02-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMViewport methods ***)
    function Init(lpD3DRMDevice: IDirect3DRMDevice;
        lpD3DRMFrameCamera: IDirect3DRMFrame; xpos, ypos, width, height: DWORD):
        HRESULT; stdcall;
    function Clear: HRESULT; stdcall;
    function Render(lpD3DRMFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function SetFront(rvFront: D3DVALUE): HRESULT; stdcall;
    function SetBack(rvBack: D3DVALUE): HRESULT; stdcall;
    function SetField(rvField: D3DVALUE): HRESULT; stdcall;
    function SetUniformScaling(bScale: BOOL): HRESULT; stdcall;
    function SetCamera(lpCamera: IDirect3DRMFrame): HRESULT; stdcall;
    function SetProjection(rptType: D3DRMPROJECTIONTYPE): HRESULT; stdcall;
    function Transform(var lprvDst: D3DRMVECTOR4D; var lprvSrc: D3DVECTOR):
        HRESULT; stdcall;
    function InverseTransform(var lprvDst: D3DVECTOR;
        var lprvSrc: D3DRMVECTOR4D): HRESULT; stdcall;
    function Configure(lX, lY: Longint; dwWidth, dwHeight: DWORD): HRESULT;
         stdcall;
    function ForceUpdate(dwX1, dwY1, dwX2, dwY2: DWORD): HRESULT; stdcall;
    function SetPlane(rvLeft, rvRight, rvBottom, rvTop: D3DVALUE): HRESULT;
         stdcall;
    function GetCamera(out lpCamera: IDirect3DRMFrame): HRESULT; stdcall;
    function GetDevice(out lpD3DRMDevice: IDirect3DRMDevice): HRESULT;  stdcall;
    function GetPlane(var lpd3dvLeft, lpd3dvRight, lpd3dvBottom,
        lpd3dvTop: D3DVALUE): HRESULT; stdcall;
    function Pick(lX, lY: Longint; out lplpVisuals: IDirect3DRMPickedArray):
        HRESULT; stdcall;
    function GetUniformScaling: BOOL; stdcall;
    function GetX: Longint; stdcall;
    function GetY: Longint; stdcall;
    function GetWidth: DWORD; stdcall;
    function GetHeight: DWORD; stdcall;
    function GetField: D3DVALUE; stdcall;
    function GetBack: D3DVALUE; stdcall;
    function GetFront: D3DVALUE; stdcall;
    function GetProjection: D3DRMPROJECTIONTYPE; stdcall;
    function GetDirect3DViewport(out lplpD3DViewport: IDirect3DViewport):
        HRESULT; stdcall;
  end;

  IDirect3DRMFrame = interface(IDirect3DRMVisual)
    ['{EB16CB03-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMFrame methods ***)
    function AddChild(lpD3DRMFrameChild: IDirect3DRMFrame): HRESULT; stdcall;
    function AddLight(lpD3DRMLight: IDirect3DRMLight): HRESULT; stdcall;
    function AddMoveCallback(d3drmFMC: D3DRMFRAMEMOVECALLBACK;
        lpArg: Pointer): HRESULT; stdcall;
    function AddTransform(rctCombine: D3DRMCOMBINETYPE;
        rmMatrix: D3DRMMATRIX4D): HRESULT; stdcall;
    function AddTranslation(rctCombine: D3DRMCOMBINETYPE; rvX, rvY,
        rvZ: D3DVALUE): HRESULT; stdcall;
    function AddScale(rctCombine: D3DRMCOMBINETYPE; rvX, rvY,
        rvZ: D3DVALUE): HRESULT; stdcall;
    function AddRotation(rctCombine: D3DRMCOMBINETYPE; rvX, rvY, rvZ,
        rvTheta: D3DVALUE): HRESULT; stdcall;
    function AddVisual(lpD3DRMVisual: IDirect3DRMVisual): HRESULT; stdcall;
    function GetChildren(out lplpChildren: IDirect3DRMFrameArray): HRESULT;
         stdcall;
    function GetColor: D3DCOLOR; stdcall;
    function GetLights(out lplpLights: IDirect3DRMLightArray): HRESULT; stdcall;
    function GetMaterialMode: D3DRMMATERIALMODE; stdcall;
    function GetParent(out lplpParent: IDirect3DRMFrame): HRESULT; stdcall;
    function GetPosition(lpRef: IDirect3DRMFrame; var lprvPos: D3DVECTOR):
        HRESULT; stdcall;
    function GetRotation(lpRef: IDirect3DRMFrame; var lprvAxis: D3DVECTOR;
        var lprvTheta: D3DVALUE): HRESULT; stdcall;
    function GetScene(out lplpRoot: IDirect3DRMFrame): HRESULT; stdcall;
    function GetSortMode: D3DRMSORTMODE; stdcall;
    function GetTexture(out lplpTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function GetTransform(var rmMatrix: D3DRMMATRIX4D): HRESULT; stdcall;
    function GetVelocity(lpRef: IDirect3DRMFrame; var lprvVel: D3DVECTOR;
        fRotVel: BOOL): HRESULT; stdcall;
    function GetOrientation(lpRef: IDirect3DRMFrame; var lprvDir: D3DVECTOR;
        var lprvUp: D3DVECTOR): HRESULT; stdcall;
    function GetVisuals(out lplpVisuals: IDirect3DRMVisualArray): HRESULT;
        stdcall;
    function GetTextureTopology(var lpU, lpV: BOOL): HRESULT; stdcall;
    function InverseTransform(var lprvDst, lprvSrc: D3DVECTOR): HRESULT;
        stdcall;
    function Load(lpvObjSource: Pointer; lpvObjID: Pointer;
        d3drmLOFlags: D3DRMLOADOPTIONS; d3drmLoadTextureProc:
        D3DRMLOADTEXTURECALLBACK; lpArgLTP: Pointer): HRESULT; stdcall;
    function LookAt(lpTarget, lpRef: IDirect3DRMFrame;
        rfcConstraint: D3DRMFRAMECONSTRAINT ): HRESULT; stdcall;
    function Move(delta: D3DVALUE): HRESULT; stdcall;
    function DeleteChild(lpChild: IDirect3DRMFrame): HRESULT; stdcall;
    function DeleteLight(lpD3DRMLight: IDirect3DRMLight): HRESULT; stdcall;
    function DeleteMoveCallback(d3drmFMC: D3DRMFRAMEMOVECALLBACK;
        lpArg: Pointer): HRESULT; stdcall;
    function DeleteVisual(lpD3DRMVisual: IDirect3DRMVisual): HRESULT; stdcall;
    function GetSceneBackground: D3DCOLOR; stdcall;
    function GetSceneBackgroundDepth(out lplpDDSurface: IDirectDrawSurface):
        HRESULT; stdcall;
    function GetSceneFogColor: D3DCOLOR; stdcall;
    function GetSceneFogEnable: BOOL; stdcall;
    function GetSceneFogMode: D3DRMFOGMODE; stdcall;
    function GetSceneFogParams(var lprvStart, lprvEnd, lprvDensity: D3DVALUE):
        HRESULT; stdcall;
    function SetSceneBackground(rcColor: D3DCOLOR): HRESULT; stdcall;
    function SetSceneBackgroundRGB(rvRed, rvGreen, rvBlue: D3DVALUE): HRESULT;
        stdcall;
    function SetSceneBackgroundDepth(lpImage: IDirectDrawSurface): HRESULT;
        stdcall;
    function SetSceneBackgroundImage(lpTexture: IDirect3DRMTexture): HRESULT;
        stdcall;
    function SetSceneFogEnable(bEnable: BOOL): HRESULT; stdcall;
    function SetSceneFogColor(rcColor: D3DCOLOR): HRESULT; stdcall;
    function SetSceneFogMode(rfMode: D3DRMFOGMODE): HRESULT; stdcall;
    function SetSceneFogParams(rvStart, rvEnd, rvDensity: D3DVALUE): HRESULT;
         stdcall;
    function SetColor(rcColor: D3DCOLOR): HRESULT; stdcall;
    function SetColorRGB(rvRed, rvGreen, rvBlue: D3DVALUE): HRESULT; stdcall;
    function GetZbufferMode: D3DRMZBUFFERMODE; stdcall;
    function SetMaterialMode(rmmMode: D3DRMMATERIALMODE): HRESULT; stdcall;
    function SetOrientation(lpRef: IDirect3DRMFrame; rvDx, rvDy, rvDz, rvUx,
        rvUy, rvUz: D3DVALUE): HRESULT; stdcall;
    function SetPosition(lpRef: IDirect3DRMFrame; rvX, rvY, rvZ: D3DVALUE):
        HRESULT; stdcall;
    function SetRotation(lpRef: IDirect3DRMFrame; rvX, rvY, rvZ,
        rvTheta: D3DVALUE): HRESULT; stdcall;
    function SetSortMode(d3drmSM: D3DRMSORTMODE): HRESULT; stdcall;
    function SetTexture(lpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function SetTextureTopology(cylU, cylV: BOOL): HRESULT; stdcall;
    function SetVelocity(lpRef: IDirect3DRMFrame; rvX, rvY, rvZ: D3DVALUE;
        fRotVel: BOOL): HRESULT; stdcall;
    function SetZbufferMode(d3drmZBM: D3DRMZBUFFERMODE): HRESULT; stdcall;
    function Transform(var lpd3dVDst, lpd3dVSrc: D3DVECTOR): HRESULT; stdcall;
  end;

  IDirect3DRMFrame2 = interface(IDirect3DRMFrame)
    ['{C3DFBD60-3988-11D0-9EC2-0000C0291AC3}']
    (*** IDirect3DRMFrame2 methods ***)
    function AddMoveCallback2(d3drmFMC: D3DRMFRAMEMOVECALLBACK; lpArg:
        Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetBox(var lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function GetBoxEnable: boolean; stdcall;
    function GetAxes(var dir, up: D3DVECTOR): HRESULT; stdcall;
    function GetMaterial(out lplpMaterial: IDirect3DRMMaterial): HRESULT;
         stdcall;
    function GetInheritAxes: boolean; stdcall;
    function GetHierarchyBox(var lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function SetBox(const lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function SetBoxEnable(bEnableFlag: BOOL): HRESULT; stdcall;
    function SetAxes(dx, dy, dz, ux, uy, uz: D3DVALUE): HRESULT; stdcall;
    function SetInheritAxes(inherit_from_parent: BOOL): HRESULT; stdcall;
    function SetMaterial(const lplpMaterial: IDirect3DRMMaterial): HRESULT;
         stdcall;
    function SetQuaternion(lpRef: IDirect3DRMFrame2; var quat: D3DRMQUATERNION):
        HRESULT; stdcall;
    function RayPick(lpRefFrame: IDirect3DRMFrame; const ray: D3DRMRAY;
        dwFlags: DWORD; out lplpPicked2Array: IDirect3DRMPicked2Array) :
        HRESULT; stdcall;
    function Save(lpFilename: PChar; d3dFormat: D3DRMXOFFORMAT;
        d3dSaveFlags: D3DRMSAVEOPTIONS): HRESULT; stdcall;
  end;

  IDirect3DRMMesh = interface(IDirect3DRMVisual)
    ['{A3A80D01-6E12-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRMMesh methods ***)
    function Scale(sx, sy, sz: D3DVALUE): HRESULT; stdcall;
    function Translate(tx, ty, tz: D3DVALUE): HRESULT; stdcall;
    function GetBox(var lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function AddGroup(vCount, fCount, vPerFace: DWORD; var fData: DWORD;
        var returnId: D3DRMGROUPINDEX): HRESULT; stdcall;
    function SetVertices(id: D3DRMGROUPINDEX; index, count: DWORD;
        var values: D3DRMVERTEX): HRESULT; stdcall;
    function SetGroupColor(id: D3DRMGROUPINDEX; value: D3DCOLOR): HRESULT;
         stdcall;
    function SetGroupColorRGB(id: D3DRMGROUPINDEX; red, green,
        blue: D3DVALUE): HRESULT; stdcall;
    function SetGroupMapping(id: D3DRMGROUPINDEX;
        value: D3DRMMAPPING): HRESULT; stdcall;
    function SetGroupQuality(id: D3DRMGROUPINDEX;
        value: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function SetGroupMaterial(id: D3DRMGROUPINDEX; value:
        IDirect3DRMMaterial): HRESULT; stdcall;
    function SetGroupTexture(id: D3DRMGROUPINDEX; value: IDirect3DRMTexture):
        HRESULT; stdcall;
    function GetGroupCount: DWORD; stdcall;
    function GetGroup(id: D3DRMGROUPINDEX; var vCount, fCount, vPerFace,
        fDataSize, fData: DWORD): HRESULT; stdcall;
    function GetVertices(id: D3DRMGROUPINDEX; index: DWORD; count: DWORD;
	var returnPtr: D3DRMVertex): HResult; stdcall;
    function GetGroupColor(id: D3DRMGROUPINDEX): D3DCOLOR; stdcall;
    function GetGroupMapping(id: D3DRMGROUPINDEX): D3DRMMAPPING; stdcall;
    function GetGroupQuality(id: D3DRMGROUPINDEX): D3DRMRENDERQUALITY; stdcall;
    function GetGroupMaterial(id: D3DRMGROUPINDEX;
        out returnPtr: IDirect3DRMMaterial): HRESULT; stdcall;
    function GetGroupTexture(id: D3DRMGROUPINDEX;
        out returnPtr: IDirect3DRMTexture): HRESULT; stdcall;
  end;

  IDirect3DRMProgressiveMesh = interface(IDirect3DRMVisual)
    ['{4516EC79-8F20-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRMProgressiveMesh methods ***)
    function Load(lpSource, lpObjID: pointer; dloLoadflags: D3DRMLOADOPTIONS;
        lpCallback: D3DRMLOADTEXTURECALLBACK; lpArg: pointer): HRESULT; stdcall;
    function GetLoadStatus(var lpStatus: D3DRMPMESHLOADSTATUS): HRESULT;
        stdcall;
    function SetMinRenderDetail(d3dVal: D3DVALUE): HRESULT; stdcall;
    function Abort(dwFlags: DWORD): HRESULT; stdcall;
    function GetFaceDetail(var lpdwCount: DWORD): HRESULT; stdcall;
    function GetVertexDetail(var lpdwCount: DWORD): HRESULT; stdcall;
    function SetFaceDetail(dwCount: DWORD): HRESULT; stdcall;
    function SetVertexDetail(dwCount: DWORD): HRESULT; stdcall;
    function GetFaceDetailRange(var lpdwMin, lpdwMax: DWORD): HRESULT; stdcall;
    function GetVertexDetailRange(var lpdwMin, lpdwMax: DWORD): HRESULT; stdcall;
    function GetDetail(var lpdvVal: D3DVALUE): HRESULT; stdcall;
    function SetDetail(lpdvVal: D3DVALUE): HRESULT; stdcall;
    function RegisterEvents(hEvent: THANDLE; dwFlags, dwReserved: DWORD):
        HRESULT; stdcall;
    function CreateMesh(out lplpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    function Duplicate(out lplpD3DRMPMesh: IDirect3DRMProgressiveMesh): HRESULT;
        stdcall;
    function GetBox(var lpBBox: D3DRMBOX): HRESULT; stdcall;
    function SetQuality(quality: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function GetQuality(var lpdwquality: D3DRMRENDERQUALITY): HRESULT; stdcall;
  end;

  IDirect3DRMShadow = interface(IDirect3DRMVisual)
    ['{AF359780-6BA3-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRMShadow methods ***)
    function Init(lpD3DRMVisual: IDirect3DRMVisual;
        lpD3DRMLight: IDirect3DRMLight; px, py, pz, nx, ny, nz: D3DVALUE):
        HRESULT; stdcall;
  end;

  IDirect3DRMFace = interface(IDirect3DRMObject)
    ['{EB16CB07-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMFace methods ***)
    function AddVertex(x, y, z: D3DVALUE): HRESULT; stdcall;
    function AddVertexAndNormalIndexed(vertex: DWORD; normal: DWORD): HRESULT;
        stdcall;
    function SetColorRGB(red, green, blue: D3DVALUE): HRESULT; stdcall;
    function SetColor(color: D3DCOLOR): HRESULT; stdcall;
    function SetTexture(lpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function SetTextureCoordinates(vertex: DWORD; u, v: D3DVALUE): HRESULT;
        stdcall;
    function SetMaterial(lpMat: IDirect3DRMMaterial): HRESULT; stdcall;
    function SetTextureTopology(cylU, cylV: BOOL): HRESULT; stdcall;
    function GetVertex(index: DWORD; var lpPosition: D3DVECTOR;
        var lpNormal: D3DVECTOR): HRESULT; stdcall;
    function GetVertices(var lpdwVertexCount: DWORD;
        var lpPosition, lpNormal: D3DVECTOR): HRESULT; stdcall;
    function GetTextureCoordinates(index: DWORD; var lpU, lpV: D3DVALUE):
        HRESULT; stdcall;
    function GetTextureTopology(var lpU, lpV: BOOL): HRESULT; stdcall;
    function GetNormal(var lpNormal: D3DVECTOR): HRESULT; stdcall;
    function GetTexture(out lplpTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function GetMaterial(out lpMat: IDirect3DRMMaterial): HRESULT; stdcall;
    function GetVertexCount: Integer; stdcall;
    function GetVertexIndex(dwIndex: DWORD): Integer; stdcall;
    function GetTextureCoordinateIndex(dwIndex: DWORD): Integer; stdcall;
    function GetColor: D3DCOLOR; stdcall;
  end;

  IDirect3DRMMeshBuilder = interface(IDirect3DRMVisual)
    ['{A3A80D02-6E12-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRMMeshBuilder methods ***)
    function Load(lpvObjSource, lpvObjID: Pointer; d3drmLOFlags:
        D3DRMLOADOPTIONS; d3drmLoadTextureProc: D3DRMLOADTEXTURECALLBACK;
        lpvArg: Pointer): HRESULT; stdcall;
    function Save(lpFilename: PChar; d3drmXOFFormat: D3DRMXOFFORMAT;
        d3drmSOContents: D3DRMSAVEOPTIONS): HRESULT; stdcall;
    function Scale(sx, sy, sz: D3DVALUE): HRESULT; stdcall;
    function Translate(tx, ty, tz: D3DVALUE): HRESULT; stdcall;
    function SetColorSource(source: D3DRMCOLORSOURCE): HRESULT; stdcall;
    function GetBox(var lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function GenerateNormals: HRESULT; stdcall;
    function GetColorSource: D3DRMCOLORSOURCE; stdcall;
    function AddMesh(lpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    function AddMeshBuilder(lpD3DRMMeshBuild: IDirect3DRMMeshBuilder): HRESULT;
        stdcall;
    function AddFrame(lpD3DRMFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function AddFace(lpD3DRMFace: IDirect3DRMFace): HRESULT; stdcall;
    function AddFaces(dwVertexCount: DWORD; var lpD3DVertices: D3DVECTOR;
        normalCount: DWORD; var lpNormals: D3DVECTOR; var lpFaceData: DWORD;
        out lplpD3DRMFaceArray: IDirect3DRMFaceArray): HRESULT; stdcall;
    function ReserveSpace(vertexCount, normalCount, faceCount: DWORD): HRESULT;
        stdcall;
    function SetColorRGB(red, green, blue: D3DVALUE): HRESULT; stdcall;
    function SetColor(color: D3DCOLOR): HRESULT; stdcall;
    function SetTexture(lpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function SetMaterial(lpIDirect3DRMmaterial: IDirect3DRMMaterial): HRESULT;
        stdcall;
    function SetTextureTopology(cylU, cylV: BOOL): HRESULT; stdcall;
    function SetQuality(quality: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function SetPerspective(perspective: BOOL): HRESULT; stdcall;
    function SetVertex(index: DWORD; x, y, z: D3DVALUE): HRESULT; stdcall;
    function SetNormal(index: DWORD; x, y, z: D3DVALUE): HRESULT; stdcall;
    function SetTextureCoordinates(index: DWORD; u, v: D3DVALUE): HRESULT;
        stdcall;
    function SetVertexColor(index: DWORD; color: D3DCOLOR): HRESULT; stdcall;
    function SetVertexColorRGB(index: DWORD; red, green, blue: D3DVALUE):
        HRESULT; stdcall;
    function GetFaces(out lplpD3DRMFaceArray: IDirect3DRMFaceArray): HRESULT;
        stdcall;
    function GetVertices(var vcount: DWORD; var vertices: D3DVECTOR;
        var ncount: DWORD; var normals: D3DVECTOR; var face_data_size: DWORD;
        var face_data: DWORD): HRESULT; stdcall;
    function GetTextureCoordinates(index: DWORD; var u, v: D3DVALUE): HRESULT;
        stdcall;
    function AddVertex(x, y, z: D3DVALUE): Integer; stdcall;
    function AddNormal(x, y, z: D3DVALUE): Integer; stdcall;
    function CreateFace(out lplpd3drmFace: IDirect3DRMFace): HRESULT; stdcall;
    function GetQuality: D3DRMRENDERQUALITY; stdcall;
    function GetPerspective: BOOL; stdcall;
    function GetFaceCount: Integer; stdcall;
    function GetVertexCount: Integer; stdcall;
    function GetVertexColor(index: DWORD): D3DCOLOR; stdcall;
    function CreateMesh(out lplpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
  end;

  IDirect3DRMMeshBuilder2 = interface(IDirect3DRMVisual)
    ['{4516EC77-8F20-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRMMeshBuilder methods ***)
    function Load(lpvObjSource, lpvObjID: Pointer; d3drmLOFlags:
        D3DRMLOADOPTIONS; d3drmLoadTextureProc: D3DRMLOADTEXTURECALLBACK;
        lpvArg: Pointer): HRESULT; stdcall;
    function Save(lpFilename: PChar; d3drmXOFFormat: D3DRMXOFFORMAT;
        d3drmSOContents: D3DRMSAVEOPTIONS): HRESULT; stdcall;
    function Scale(sx, sy, sz: D3DVALUE): HRESULT; stdcall;
    function Translate(tx, ty, tz: D3DVALUE): HRESULT; stdcall;
    function SetColorSource(source: D3DRMCOLORSOURCE): HRESULT; stdcall;
    function GetBox(var lpD3DRMBox: D3DRMBOX): HRESULT; stdcall;
    function GenerateNormals: HRESULT; stdcall;
    function GetColorSource: D3DRMCOLORSOURCE; stdcall;
    function AddMesh(lpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    function AddMeshBuilder(lpD3DRMMeshBuild: IDirect3DRMMeshBuilder):
        HRESULT; stdcall;
    function AddFrame(lpD3DRMFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function AddFace(lpD3DRMFace: IDirect3DRMFace): HRESULT; stdcall;
    function AddFaces(dwVertexCount: DWORD; var lpD3DVertices: D3DVECTOR;
        normalCount: DWORD; var lpNormals: D3DVECTOR; var lpFaceData: DWORD;
        out lplpD3DRMFaceArray: IDirect3DRMFaceArray): HRESULT;
        stdcall;
    function ReserveSpace(vertexCount, normalCount, faceCount: DWORD):
        HRESULT; stdcall;
    function SetColorRGB(red, green, blue: D3DVALUE): HRESULT; stdcall;
    function SetColor(color: D3DCOLOR): HRESULT; stdcall;
    function SetTexture(lpD3DRMTexture: IDirect3DRMTexture): HRESULT; stdcall;
    function SetMaterial(lpIDirect3DRMmaterial: IDirect3DRMMaterial):
        HRESULT; stdcall;
    function SetTextureTopology(cylU, cylV: BOOL): HRESULT; stdcall;
    function SetQuality(quality: D3DRMRENDERQUALITY): HRESULT; stdcall;
    function SetPerspective(perspective: BOOL): HRESULT; stdcall;
    function SetVertex(index: DWORD; x, y, z: D3DVALUE): HRESULT; stdcall;
    function SetNormal(index: DWORD; x, y, z: D3DVALUE): HRESULT; stdcall;
    function SetTextureCoordinates(index: DWORD; u, v: D3DVALUE): HRESULT; stdcall;
    function SetVertexColor(index: DWORD; color: D3DCOLOR): HRESULT; stdcall;
    function SetVertexColorRGB(index: DWORD; red, green, blue: D3DVALUE):
        HRESULT; stdcall;
    function GetFaces(out lplpD3DRMFaceArray: IDirect3DRMFaceArray): HRESULT;
        stdcall;
    function GetVertices(var vcount: DWORD; var vertices: D3DVECTOR;
        var ncount: DWORD; var normals: D3DVECTOR; var face_data_size: DWORD;
        var face_data: DWORD): HRESULT; stdcall;
    function GetTextureCoordinates(index: DWORD; var u, v: D3DVALUE): HRESULT;
        stdcall;
    function AddVertex(x, y, z: D3DVALUE): Integer; stdcall;
    function AddNormal(x, y, z: D3DVALUE): Integer; stdcall;
    function CreateFace(out lplpd3drmFace: IDirect3DRMFace): HRESULT; stdcall;
    function GetQuality: D3DRMRENDERQUALITY; stdcall;
    function GetPerspective: BOOL; stdcall;
    function GetFaceCount: Integer; stdcall;
    function GetVertexCount: Integer; stdcall;
    function GetVertexColor(index: DWORD): D3DCOLOR; stdcall;
    function CreateMesh(out lplpD3DRMMesh: IDirect3DRMMesh): HRESULT; stdcall;
    (*** IDirect3DRMMeshBuilder2 methods ***)
    function GenerateNormals2(dvCreaseAngle: D3DVALUE; dwFlags: DWORD) :
        HRESULT; stdcall;
    function GetFace(dwIndex: DWORD; out lplpD3DRMFace: IDirect3DRMFace) :
        HRESULT; stdcall;
  end;

  IDirect3DRMLight = interface(IDirect3DRMObject)
    ['{EB16CB08-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMLight methods ***)
    function SetType(d3drmtType: D3DRMLIGHTTYPE): HRESULT; stdcall;
    function SetColor(rcColor: D3DCOLOR): HRESULT; stdcall;
    function SetColorRGB(rvRed, rvGreen, rvBlue: D3DVALUE): HRESULT; stdcall;
    function SetRange(rvRange: D3DVALUE): HRESULT; stdcall;
    function SetUmbra(rvAngle: D3DVALUE): HRESULT; stdcall;
    function SetPenumbra(rvAngle: D3DVALUE): HRESULT; stdcall;
    function SetConstantAttenuation(rvAtt: D3DVALUE): HRESULT; stdcall;
    function SetLinearAttenuation(rvAtt: D3DVALUE): HRESULT; stdcall;
    function SetQuadraticAttenuation(rvAtt: D3DVALUE): HRESULT; stdcall;
    function GetRange: D3DVALUE; stdcall;
    function GetUmbra: D3DVALUE; stdcall;
    function GetPenumbra: D3DVALUE; stdcall;
    function GetConstantAttenuation: D3DVALUE; stdcall;
    function GetLinearAttenuation: D3DVALUE; stdcall;
    function GetQuadraticAttenuation: D3DVALUE; stdcall;
    function GetColor: D3DCOLOR; stdcall;
    function GetType: D3DRMLIGHTTYPE; stdcall;
    function SetEnableFrame(lpEnableFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function GetEnableFrame(out lplpEnableFrame: IDirect3DRMFrame): HRESULT;
        stdcall;
  end;

  IDirect3DRMTexture = interface(IDirect3DRMVisual)
    ['{EB16CB09-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMTexture methods ***)
    function InitFromFile(filename: PChar): HRESULT; stdcall;
    function InitFromSurface(lpDDS: IDirectDrawSurface): HRESULT; stdcall;
    function InitFromResource(rs: HRSRC): HRESULT; stdcall;
    function Changed(bPixels, bPalette: BOOL): HRESULT; stdcall;
    function SetColors(ulColors: DWORD): HRESULT; stdcall;
    function SetShades(ulShades: DWORD): HRESULT; stdcall;
    function SetDecalSize(rvWidth, rvHeight: D3DVALUE): HRESULT; stdcall;
    function SetDecalOrigin(lX, lY: Longint): HRESULT; stdcall;
    function SetDecalScale(dwScale: DWORD): HRESULT; stdcall;
    function SetDecalTransparency(bTransp: BOOL): HRESULT; stdcall;
    function SetDecalTransparentColor(rcTransp: D3DCOLOR): HRESULT; stdcall;
    function GetDecalSize(var lprvWidth, lprvHeight: D3DVALUE): HRESULT; stdcall;
    function GetDecalOrigin(var lplX, lplY: Longint): HRESULT; stdcall;
    function GetImage: LPD3DRMIMAGE; stdcall;
    function GetShades: DWORD; stdcall;
    function GetColors: DWORD; stdcall;
    function GetDecalScale: DWORD; stdcall;
    function GetDecalTransparency: BOOL; stdcall;
    function GetDecalTransparentColor: D3DCOLOR; stdcall;
  end;

  IDirect3DRMTexture2 = interface(IDirect3DRMTexture)
    ['{120F30C0-1629-11D0-941C-0080C80CFA7B}']
    (*** IDirect3DRMTexture2 methods ***)
    function InitFromImage(const lpImage: D3DRMIMAGE): HRESULT; stdcall;
    function InitFromResource2(hModule: HModule; strName, strType: PChar):
        HRESULT; stdcall;
    function GenerateMIPMap(dwFlags: DWORD): HRESULT; stdcall;
  end;

  IDirect3DRMWrap = interface(IDirect3DRMObject)
    ['{EB16CB0A-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMWrap methods ***)
    function Init(d3drmwt: D3DRMWRAPTYPE; lpd3drmfRef: IDirect3DRMFrame;
        ox, oy, oz, dx, dy, dz, ux, uy, uz, ou, ov, su, sv: D3DVALUE):
        HRESULT; stdcall;
    function Apply(lpObject: IDirect3DRMObject): HRESULT; stdcall;
    function ApplyRelative(frame: IDirect3DRMFrame; mesh: IDirect3DRMObject):
        HRESULT; stdcall;
  end;

  IDirect3DRMMaterial = interface(IDirect3DRMObject)
    ['{EB16CB0B-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMMaterial methods ***)
    function SetPower(rvPower: D3DVALUE): HRESULT; stdcall;
    function SetSpecular(r, g, b: D3DVALUE): HRESULT; stdcall;
    function SetEmissive(r, g, b: D3DVALUE): HRESULT; stdcall;
    function GetPower: D3DVALUE; stdcall;
    function GetSpecular(var lpr, lpg, lpb: D3DVALUE): HRESULT; stdcall;
    function GetEmissive(var lpr, lpg, lpb: D3DVALUE): HRESULT; stdcall;
  end;

  IDirect3DRMAnimation = interface(IDirect3DRMObject)
    ['{EB16CB0D-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMAnimation methods ***)
    function SetOptions(d3drmanimFlags: D3DRMANIMATIONOPTIONS): HRESULT;
        stdcall;
    function AddRotateKey(rvTime: D3DVALUE; var rqQuat: D3DRMQUATERNION):
        HRESULT; stdcall;
    function AddPositionKey(rvTime, rvX, rvY, rvZ: D3DVALUE): HRESULT; stdcall;
    function AddScaleKey(time, x, y, z: D3DVALUE): HRESULT; stdcall;
    function DeleteKey(time: D3DVALUE): HRESULT; stdcall;
    function SetFrame(lpD3DRMFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function SetTime(rvTime: D3DVALUE): HRESULT; stdcall;
    function GetOptions: D3DRMANIMATIONOPTIONS; stdcall;
  end;

  IDirect3DRMAnimationSet = interface(IDirect3DRMObject)
    ['{EB16CB0E-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMAnimationSet methods ***)
    function AddAnimation(lpD3DRMAnimation: IDirect3DRMAnimation): HRESULT;
         stdcall;
    function Load(lpvObjSource, lpvObjID: Pointer;
        d3drmLOFlags: D3DRMLOADOPTIONS;
        d3drmLoadTextureProc: D3DRMLOADTEXTURECALLBACK; lpArgLTP: Pointer;
        lpParentFrame: IDirect3DRMFrame): HRESULT; stdcall;
    function DeleteAnimation(lpD3DRMAnimation: IDirect3DRMAnimation): HRESULT;
        stdcall;
    function SetTime(rvTime: D3DVALUE): HRESULT; stdcall;
  end;

  IDirect3DRMUserVisual = interface(IDirect3DRMVisual)
    ['{59163DE0-6D43-11CF-AC4A-0000C03825A1}']
    (*** IDirect3DRMUserVisual methods ***)
    function Init(d3drmUVProc: D3DRMUSERVISUALCALLBACK; lpArg: Pointer):
        HRESULT; stdcall;
  end;

  IDirect3DRMArray = interface(IUnknown)
    function GetSize: DWORD; stdcall;
    (* No GetElement method as it would get overloaded
     * in derived classes, and overloading is
     * a no-no in COM
     *)
  end;

  IDirect3DRMObjectArray = interface(IDirect3DRMArray)
    function GetElement(index: DWORD; out lplpD3DRMObject:
        IDirect3DRMObject): HRESULT; stdcall;
  end;

  IDirect3DRMDeviceArray = interface(IDirect3DRMArray)
    ['{EB16CB10-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMDeviceArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMDevice:
        IDirect3DRMDevice): HRESULT; stdcall;
  end;

  IDirect3DRMFrameArray = interface(IDirect3DRMArray)
    ['{EB16CB12-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMFrameArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMFrame: IDirect3DRMFrame):
        HRESULT; stdcall;
  end;

  IDirect3DRMViewportArray = interface(IDirect3DRMArray)
    ['{EB16CB11-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMViewportArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMViewport:
        IDirect3DRMViewport): HRESULT; stdcall;
  end;

  IDirect3DRMVisualArray = interface(IDirect3DRMArray)
    ['{EB16CB13-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMVisualArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMVisual:
        IDirect3DRMVisual): HRESULT; stdcall;
  end;

  IDirect3DRMPickedArray = interface(IDirect3DRMArray)
    ['{EB16CB16-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMPickedArray methods ***)
    function GetPick(index: DWORD; out lplpVisual: IDirect3DRMVisual;
        out lplpFrameArray: IDirect3DRMFrameArray;
        var lpD3DRMPickDesc: D3DRMPICKDESC): HRESULT; stdcall;
  end;

  IDirect3DRMLightArray = interface(IDirect3DRMArray)
    ['{EB16CB14-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMLightArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMLight: IDirect3DRMLight):
        HRESULT; stdcall;
  end;

  IDirect3DRMFaceArray = interface(IDirect3DRMArray)
    ['{EB16CB17-D271-11CE-AC48-0000C03825A1}']
    (*** IDirect3DRMFaceArray methods ***)
    function GetElement(index: DWORD; out lplpD3DRMFace: IDirect3DRMFace):
        HRESULT; stdcall;
  end;

  IDirect3DRMPicked2Array = interface(IDirect3DRMArray)
    ['{4516EC7B-8F20-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRMPicked2Array methods ***)
    function GetPick(index: DWORD; out lplpVisual: IDirect3DRMVisual;
        lplpFrameArray: IDirect3DRMFrameArray; out lpD3DRMPickDesc2:
	D3DRMPICKDESC2): HRESULT; stdcall;
  end;

  IDirect3DRMInterpolator = interface(IDirect3DRMObject)
    ['{242F6BC1-3849-11D0-9B6D-0000C0781BC3}']
    (*** IDirect3DRMInterpolator methods ***)
    function AttachObject(lpD3DRMObject: IDirect3DRMObject): HRESULT; stdcall;
    function GetAttachedObjects(lpD3DRMObjectArray: IDirect3DRMObjectArray):
        HRESULT; stdcall;
    function DetachObject(lpD3DRMObject: IDirect3DRMObject): HRESULT; stdcall;
    function SetIndex(d3dVal: D3DVALUE): HRESULT; stdcall;
    function GetIndex: D3DVALUE; stdcall;
    function Interpolate(d3dVal: D3DVALUE; lpD3DRMObject: IDirect3DRMObject;
	d3drmInterpFlags: D3DRMINTERPOLATIONOPTIONS): HRESULT; stdcall;
  end;

implementation

end.

