
(*==========================================================================;
 *
 *  Copyright (C) 1996-1997 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       dinput.h
 *  Content:    DirectInput include file
 *
 ****************************************************************************)

unit DInput;

interface

{$Z4}
{$A+}

uses Windows;

const
{$IFDEF DIRECTX3}
  DIRECTINPUT_VERSION = $0300;
{$ELSE}
  DIRECTINPUT_VERSION = $0500;
{$ENDIF}

(****************************************************************************
 *
 *      Class IDs
 *
 ****************************************************************************)

const
  CLSID_DirectInput: TGUID = (D1:$25E609E0;D2:$B259;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  CLSID_DirectInputDevice: TGUID = (D1:$25E609E1;D2:$B259;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

(****************************************************************************
 *
 *      Interfaces
 *
 ****************************************************************************)

const
  IID_IDirectInput: TGUID = (D1:$89521360;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputA: TGUID = (D1:$89521360;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputW: TGUID = (D1:$89521361;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInput2: TGUID = (D1:$5944E662;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInput2A: TGUID = (D1:$5944E662;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInput2W: TGUID = (D1:$5944E663;D2:$AA8A;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

  IID_IDirectInputDevice: TGUID = (D1:$5944E680;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputDeviceA: TGUID = (D1:$5944E680;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputDeviceW: TGUID = (D1:$5944E681;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputDevice2: TGUID = (D1:$5944E682;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputDevice2A: TGUID = (D1:$5944E682;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  IID_IDirectInputDevice2W: TGUID = (D1:$5944E683;D2:$C92E;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

  IID_IDirectInputEffect: TGUID = (D1:$E7E1F7C0;D2:$88D2;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));

(****************************************************************************
 *
 *      Predefined object types
 *
 ****************************************************************************)

const
  GUID_XAxis: TGUID = (D1:$A36D02E0;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_YAxis: TGUID = (D1:$A36D02E1;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_ZAxis: TGUID = (D1:$A36D02E2;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_RxAxis: TGUID = (D1:$A36D02F4;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_RyAxis: TGUID = (D1:$A36D02F5;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_RzAxis: TGUID = (D1:$A36D02E3;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_Slider: TGUID = (D1:$A36D02E4;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

  GUID_Button: TGUID = (D1:$A36D02F0;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_Key: TGUID = (D1:$55728220;D2:$D33C;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

  GUID_POV: TGUID = (D1:$A36D02F2;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

  GUID_Unknown: TGUID = (D1:$A36D02F3;D2:$C9F3;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

(****************************************************************************
 *
 *      Predefined product GUIDs
 *
 ****************************************************************************)

const
  GUID_SysMouse: TGUID = (D1:$6F1D2B60;D2:$D5A0;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_SysKeyboard: TGUID = (D1:$6F1D2B61;D2:$D5A0;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));
  GUID_Joystick: TGUID = (D1:$6F1D2B70;D2:$D5A0;D3:$11CF;D4:($BF,$C7,$44,$45,$53,$54,$00,$00));

(****************************************************************************
 *
 *      Predefined force feedback effects
 *
 ****************************************************************************)

const
  GUID_ConstantForce: TGUID = (D1:$13541C20;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_RampForce: TGUID = (D1:$13541C21;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Square: TGUID = (D1:$13541C22;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Sine: TGUID = (D1:$13541C23;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Triangle: TGUID = (D1:$13541C24;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_SawtoothUp: TGUID = (D1:$13541C25;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_SawtoothDown: TGUID = (D1:$13541C26;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Spring: TGUID = (D1:$13541C27;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Damper: TGUID = (D1:$13541C28;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Inertia: TGUID = (D1:$13541C29;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_Friction: TGUID = (D1:$13541C2A;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));
  GUID_CustomForce: TGUID = (D1:$13541C2B;D2:$8E33;D3:$11D0;D4:($9A,$D0,$00,$A0,$C9,$A0,$6E,$35));

(****************************************************************************
 *
 *      IDirectInputEffect
 *
 ****************************************************************************)

const
  DIEFT_ALL                = $00000000;

  DIEFT_CONSTANTFORCE      = $00000001;
  DIEFT_RAMPFORCE          = $00000002;
  DIEFT_PERIODIC           = $00000003;
  DIEFT_CONDITION          = $00000004;
  DIEFT_CUSTOMFORCE        = $00000005;
  DIEFT_HARDWARE           = $000000FF;

  DIEFT_FFATTACK           = $00000200;
  DIEFT_FFFADE             = $00000400;
  DIEFT_SATURATION         = $00000800;
  DIEFT_POSNEGCOEFFICIENTS = $00001000;
  DIEFT_POSNEGSATURATION   = $00002000;
  DIEFT_DEADBAND           = $00004000;

function DIEFT_GETTYPE(n: DWORD): DWORD;

const
  DI_DEGREES               = 100;
  DI_FFNOMINALMAX          = 10000;
  DI_SECONDS               = 1000000;

type
  DICONSTANTFORCE = record
    lMagnitude: Longint;
  end;
  LPDICONSTANTFORCE = ^DICONSTANTFORCE;

  DIRAMPFORCE = record
    lStart: Longint;
    lEnd: Longint;
  end;
  LPDIRAMPFORCE = ^DIRAMPFORCE;

  DIPERIODIC = record
    dwMagnitude: DWORD;
    lOffset: Longint;
    dwPhase: DWORD;
    dwPeriod: DWORD;
  end;
  LPDIPERIODIC = ^DIPERIODIC;

  DICONDITION = record
    lOffset: Longint;
    lPositiveCoefficient: Longint;
    lNegativeCoefficient: Longint;
    dwPositiveSaturation: DWORD;
    dwNegativeSaturation: DWORD;
    lDeadBand: Longint;
  end;
  LPDICONDITION = ^DICONDITION;

  DICUSTOMFORCE = record
    cChannels: DWORD;
    dwSamplePeriod: DWORD;
    cSamples: DWORD;
    rglForceData: PLongint;
  end;
  LPDICUSTOMFORCE = ^DICUSTOMFORCE;

  DIENVELOPE = record
    dwSize: DWORD;                   (* sizeof(DIENVELOPE)   *)
    dwAttackLevel: DWORD;
    dwAttackTime: DWORD;             (* Microseconds         *)
    dwFadeLevel: DWORD;
    dwFadeTime: DWORD;               (* Microseconds         *)
  end;
  LPDIENVELOPE = ^DIENVELOPE;

  DIEFFECT = record
    dwSize: DWORD;                   (* sizeof(DIEFFECT)     *)
    dwFlags: DWORD;                  (* DIEFF_*              *)
    dwDuration: DWORD;               (* Microseconds         *)
    dwSamplePeriod: DWORD;           (* Microseconds         *)
    dwGain: DWORD;
    dwTriggerButton: DWORD;          (* or DIEB_NOTRIGGER    *)
    dwTriggerRepeatInterval: DWORD;  (* Microseconds         *)
    cAxes: DWORD;                    (* Number of axes       *)
    rgdwAxes: LPDWORD;               (* Array of axes        *)
    rglDirection: PLongint;          (* Array of directions  *)
    lpEnvelope: LPDIENVELOPE;        (* Optional             *)
    cbTypeSpecificParams: DWORD;     (* Size of params       *)
    lpvTypeSpecificParams: Pointer;  (* Pointer to params    *)
  end;
  LPDIEFFECT = ^DIEFFECT;

const
  DIEFF_OBJECTIDS             = $00000001;
  DIEFF_OBJECTOFFSETS         = $00000002;
  DIEFF_CARTESIAN             = $00000010;
  DIEFF_POLAR                 = $00000020;
  DIEFF_SPHERICAL             = $00000040;

  DIEP_DURATION               = $00000001;
  DIEP_SAMPLEPERIOD           = $00000002;
  DIEP_GAIN = $00000004;
  DIEP_TRIGGERBUTTON          = $00000008;
  DIEP_TRIGGERREPEATINTERVAL  = $00000010;
  DIEP_AXES                   = $00000020;
  DIEP_DIRECTION              = $00000040;
  DIEP_ENVELOPE               = $00000080;
  DIEP_TYPESPECIFICPARAMS     = $00000100;
  DIEP_ALLPARAMS              = $000001FF;
  DIEP_START                  = $20000000;
  DIEP_NORESTART              = $40000000;
  DIEP_NODOWNLOAD             = $80000000;
  DIEB_NOTRIGGER              = $FFFFFFFF;

  DIES_SOLO                   = $00000001;
  DIES_NODOWNLOAD             = $80000000;

  DIEGES_PLAYING              = $00000001;
  DIEGES_EMULATED             = $00000002;

type
  DIEFFESCAPE = record
    dwSize: DWORD;
    dwCommand: DWORD;
    lpvInBuffer: Pointer;
    cbInBuffer: DWORD;
    lpvOutBuffer: Pointer;
    cbOutBuffer: DWORD;
  end;
  LPDIEFFESCAPE = ^DIEFFESCAPE;

  IDirectInputEffect = interface(IUnknown)
    ['{E7E1F7C0-88D2-11D0-9AD0-00A0C9A06E35}']
    (*** IDirectInputEffect methods ***)
    function Initialize(hinst: THandle; dwVersion: DWORD; const rguid: TGUID):
        HRESULT; stdcall;
    function GetEffectGuid(var pguid: TGUID): HRESULT; stdcall;
    function GetParameters(var peff: DIEFFECT; dwFlags: DWORD): HRESULT;
        stdcall;
    function SetParameters(const peff: DIEFFECT; dwFlags: DWORD): HRESULT;
        stdcall;
    function Start(dwIterations: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function Stop: HRESULT; stdcall;
    function GetEffectStatus(var pdwFlags: DWORD): HRESULT; stdcall;
    function DownLoad: HRESULT; stdcall;
    function Unload: HRESULT; stdcall;
    function Escape(const pesc: DIEFFESCAPE): HRESULT; stdcall;
  end;

(****************************************************************************
 *
 *      IDirectInputDevice
 *
 ****************************************************************************)

const
  DIDEVTYPE_DEVICE   = 1;
  DIDEVTYPE_MOUSE    = 2;
  DIDEVTYPE_KEYBOARD = 3;
  DIDEVTYPE_JOYSTICK = 4;
  DIDEVTYPE_HID      = $00010000;

  DIDEVTYPEMOUSE_UNKNOWN     = 1;
  DIDEVTYPEMOUSE_TRADITIONAL = 2;
  DIDEVTYPEMOUSE_FINGERSTICK = 3;
  DIDEVTYPEMOUSE_TOUCHPAD    = 4;
  DIDEVTYPEMOUSE_TRACKBALL   = 5;

  DIDEVTYPEKEYBOARD_UNKNOWN     = 0;
  DIDEVTYPEKEYBOARD_PCXT        = 1;
  DIDEVTYPEKEYBOARD_OLIVETTI    = 2;
  DIDEVTYPEKEYBOARD_PCAT        = 3;
  DIDEVTYPEKEYBOARD_PCENH       = 4;
  DIDEVTYPEKEYBOARD_NOKIA1050   = 5;
  DIDEVTYPEKEYBOARD_NOKIA9140   = 6;
  DIDEVTYPEKEYBOARD_NEC98       = 7;
  DIDEVTYPEKEYBOARD_NEC98LAPTOP = 8;
  DIDEVTYPEKEYBOARD_NEC98106    = 9;
  DIDEVTYPEKEYBOARD_JAPAN106    = 10;
  DIDEVTYPEKEYBOARD_JAPANAX     = 11;
  DIDEVTYPEKEYBOARD_J3100       = 12;

  DIDEVTYPEJOYSTICK_UNKNOWN     = 1;
  DIDEVTYPEJOYSTICK_TRADITIONAL = 2;
  DIDEVTYPEJOYSTICK_FLIGHTSTICK = 3;
  DIDEVTYPEJOYSTICK_GAMEPAD     = 4;
  DIDEVTYPEJOYSTICK_RUDDER      = 5;
  DIDEVTYPEJOYSTICK_WHEEL       = 6;
  DIDEVTYPEJOYSTICK_HEADTRACKER = 7;

function GET_DIDEVICE_TYPE(dwDevType: DWORD): DWORD;
function GET_DIDEVICE_SUBTYPE(dwDevType: DWORD): DWORD;

type
  DIDEVCAPS = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwDevType: DWORD;
    dwAxes: DWORD;
    dwButtons: DWORD;
    dwPOVs: DWORD;
{$IFNDEF DIRECTX3}
    dwFFSamplePeriod: DWORD;
    dwFFMinTimeResolution: DWORD;
    dwFirmwareRevision: DWORD;
    dwHardwareRevision: DWORD;
    dwFFDriverVersion: DWORD;
{$ENDIF}
  end;
  LPDIDEVCAPS = ^DIDEVCAPS;

const
  DIDC_ATTACHED           = $00000001;
  DIDC_POLLEDDEVICE       = $00000002;
  DIDC_EMULATED           = $00000004;
  DIDC_POLLEDDATAFORMAT   = $00000008;

  DIDC_FORCEFEEDBACK      = $00000100;
  DIDC_FFATTACK           = $00000200;
  DIDC_FFFADE             = $00000400;
  DIDC_SATURATION         = $00000800;
  DIDC_POSNEGCOEFFICIENTS = $00001000;
  DIDC_POSNEGSATURATION   = $00002000;
  DIDC_DEADBAND           = $00004000;

  DIDFT_ALL        = $00000000;

  DIDFT_RELAXIS    = $00000001;
  DIDFT_ABSAXIS    = $00000002;
  DIDFT_AXIS       = $00000003;

  DIDFT_PSHBUTTON  = $00000004;
  DIDFT_TGLBUTTON  = $00000008;
  DIDFT_BUTTON     = $0000000C;

  DIDFT_POV        = $00000010;

  DIDFT_COLLECTION = $00000040;
  DIDFT_NODATA     = $00000080;

  DIDFT_ANYINSTANCE = $00FFFF00;
  DIDFT_INSTANCEMASK = DIDFT_ANYINSTANCE;

function DIDFT_MAKEINSTANCE(n: WORD): DWORD;
function DIDFT_GETINSTANCE(n: DWORD): WORD;

const
  DIDFT_FFACTUATOR = $01000000;
  DIDFT_FFEFFECTTRIGGER = $02000000;

function DIDFT_ENUMCOLLECTION(n: WORD): DWORD;

const
  DIDFT_NOCOLLECTION = $00FFFF00;

type
  DIOBJECTDATAFORMAT = record
    pguid: PGUID;
    dwOfs: DWORD;
    dwType: DWORD;
    dwFlags: DWORD;
  end;
  LPDIOBJECTDATAFORMAT = ^DIOBJECTDATAFORMAT;

  DIDATAFORMAT = record
    dwSize: DWORD;
    dwObjSize: DWORD;
    dwFlags: DWORD;
    dwDataSize: DWORD;
    dwNumObjs: DWORD;
    rgodf: LPDIOBJECTDATAFORMAT;
  end;
  LPDIDATAFORMAT = ^DIDATAFORMAT;

const
  DIDF_ABSAXIS = $00000001;
  DIDF_RELAXIS = $00000002;

type
  DIDEVICEOBJECTINSTANCEA = record
    dwSize: DWORD;
    guidType: TGUID;
    dwOfs: DWORD;
    dwType: DWORD;
    dwFlags: DWORD;
    tszName: array[0..MAX_PATH-1] of CHAR;
{$IFNDEF DIRECTX3}
    dwFFMaxForce: DWORD;
    dwFFForceResolution: DWORD;
    wCollectionNumber: WORD;
    wDesignatorIndex: WORD;
    wUsagePage: WORD;
    wUsage: WORD;
    dwDimension: DWORD;
    wExponent: WORD;
    wReserved: WORD;
{$ENDIF}
  end;
  LPDIDEVICEOBJECTINSTANCEA = ^DIDEVICEOBJECTINSTANCEA;

  DIDEVICEOBJECTINSTANCEW = record
    dwSize: DWORD;
    guidType: TGUID;
    dwOfs: DWORD;
    dwType: DWORD;
    dwFlags: DWORD;
    tszName: array[0..MAX_PATH-1] of WCHAR;
{$IFNDEF DIRECTX3}
    dwFFMaxForce: DWORD;
    dwFFForceResolution: DWORD;
    wCollectionNumber: WORD;
    wDesignatorIndex: WORD;
    wUsagePage: WORD;
    wUsage: WORD;
    dwDimension: DWORD;
    wExponent: WORD;
    wReserved: WORD;
{$ENDIF}
  end;
  LPDIDEVICEOBJECTINSTANCEW = ^DIDEVICEOBJECTINSTANCEW;

  DIDEVICEOBJECTINSTANCE = DIDEVICEOBJECTINSTANCEA;
  LPDIDEVICEOBJECTINSTANCE = LPDIDEVICEOBJECTINSTANCEA;

  LPDIENUMDEVICEOBJECTSCALLBACKA = function(const peff: DIDEVICEOBJECTINSTANCEA;
      pvRef: Pointer): BOOL; stdcall;
  LPDIENUMDEVICEOBJECTSCALLBACKW = function(const peff: DIDEVICEOBJECTINSTANCEW;
      pvRef: Pointer): BOOL; stdcall;

  LPDIENUMDEVICEOBJECTSCALLBACK = LPDIENUMDEVICEOBJECTSCALLBACKA;

const
  DIDOI_FFACTUATOR      = $00000001;
  DIDOI_FFEFFECTTRIGGER = $00000002;
  DIDOI_POLLED          = $00008000;
  DIDOI_ASPECTPOSITION  = $00000100;
  DIDOI_ASPECTVELOCITY  = $00000200;
  DIDOI_ASPECTACCEL     = $00000300;
  DIDOI_ASPECTFORCE     = $00000400;
  DIDOI_ASPECTMASK      = $00000F00;

type
  DIPROPHEADER = record
    dwSize: DWORD;
    dwHeaderSize: DWORD;
    dwObj: DWORD;
    dwHow: DWORD;
  end;
  LPDIPROPHEADER = ^DIPROPHEADER;

const
  DIPH_DEVICE   = 0;
  DIPH_BYOFFSET = 1;
  DIPH_BYID     = 2;

type
  DIPROPDWORD = record
    diph: DIPROPHEADER;
    dwData: DWORD;
  end;
  LPDIPROPDWORD = ^DIPROPDWORD;

  DIPROPRANGE = record
    diph: DIPROPHEADER;
    lMin: Longint;
    lMax: Longint;
  end;
  LPDIPROPRANGE = ^DIPROPRANGE;

const
  DIPROPRANGE_NOMIN   = $80000000;
  DIPROPRANGE_NOMAX   = $7FFFFFFF;

  DIPROP_BUFFERSIZE   = PGUID(1);
  DIPROP_AXISMODE     = PGUID(2);

  DIPROPAXISMODE_ABS  = 0;
  DIPROPAXISMODE_REL  = 1;

  DIPROP_GRANULARITY  = PGUID(3);
  DIPROP_RANGE        = PGUID(4);
  DIPROP_DEADZONE     = PGUID(5);
  DIPROP_SATURATION   = PGUID(6);
  DIPROP_FFGAIN       = PGUID(7);
  DIPROP_FFLOAD       = PGUID(8);
  DIPROP_AUTOCENTER   = PGUID(9);

  DIPROPAUTOCENTER_OFF = 0;
  DIPROPAUTOCENTER_ON  = 1;

  DIPROP_CALIBRATIONMODE = PGUID(10);

  DIPROPCALIBRATIONMODE_COOKED = 0;
  DIPROPCALIBRATIONMODE_RAW    = 1;

type
  DIDEVICEOBJECTDATA = record
    dwOfs: DWORD;
    dwData: DWORD;
    dwTimeStamp: DWORD;
    dwSequence: DWORD;
  end;
  LPDIDEVICEOBJECTDATA = ^DIDEVICEOBJECTDATA;

const
  DIGDD_PEEK = $00000001;

// #define DISEQUENCE_COMPARE(dwSequence1, cmp, dwSequence2) \
//                        ((int)((dwSequence1) - (dwSequence2)) cmp 0)
  DISCL_EXCLUSIVE    = $00000001;
  DISCL_NONEXCLUSIVE = $00000002;
  DISCL_FOREGROUND   = $00000004;
  DISCL_BACKGROUND   = $00000008;

type
  DIDEVICEINSTANCEA = record
    dwSize: DWORD;
    guidInstance: TGUID;
    guidProduct: TGUID;
    dwDevType: DWORD;
    tszInstanceName: array[0..MAX_PATH-1] of CHAR;
    tszProductName: array[0..MAX_PATH-1] of CHAR;
{$IFNDEF DIRECTX3}
    guidFFDriver: TGUID;
    wUsagePage: WORD;
    wUsage: WORD;
{$ENDIF}
  end;
  LPDIDEVICEINSTANCEA = ^DIDEVICEINSTANCEA;

  DIDEVICEINSTANCEW = record
    dwSize: DWORD;
    guidInstance: TGUID;
    guidProduct: TGUID;
    dwDevType: DWORD;
    tszInstanceName: array[0..MAX_PATH-1] of WCHAR;
    tszProductName: array[0..MAX_PATH-1] of WCHAR;
{$IFNDEF DIRECTX3}
    guidFFDriver: TGUID;
    wUsagePage: WORD;
    wUsage: WORD;
{$ENDIF}
  end;
  LPDIDEVICEINSTANCEW = ^DIDEVICEINSTANCEW;

  DIDEVICEINSTANCE = DIDEVICEINSTANCEA;
  LPDIDEVICEINSTANCE = LPDIDEVICEINSTANCEA;

  IDirectInputDeviceW = interface(IUnknown)
    ['{5944E681-C92E-11CF-BFC7-444553540000}']
    (*** IDirectInputDeviceW methods ***)
    function GetCapabilities(var lpDIDevCaps: DIDEVCAPS): HRESULT; stdcall;
    function EnumObjects(lpCallback: LPDIENUMDEVICEOBJECTSCALLBACKW;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetProperty(rguidProp: PGUID; var pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function SetProperty(rguidProp: PGUID; const pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function Acquire: HRESULT; stdcall;
    function Unacquire: HRESULT; stdcall;
    function GetDeviceState(cbData: DWORD; var lpvData): HRESULT; stdcall;
    function GetDeviceData(cbObjectData: DWORD; var rgdod: DIDEVICEOBJECTDATA;
        var pdwInOut: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function SetDataFormat(const lpdf: DIDATAFORMAT): HRESULT; stdcall;
    function SetEventNotification(hEvent: THandle): HRESULT; stdcall;
    function SetCooperativeLevel(hwnd: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function GetObjectInfo(var pdidoi: DIDEVICEOBJECTINSTANCEW; dwObj: DWORD;
        dwHow: DWORD): HRESULT; stdcall;
    function GetDeviceInfo(var pdidi: DIDEVICEINSTANCEW): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD; const rguid: TGUID):
        HRESULT; stdcall;
  end;

  IDirectInputDeviceA = interface(IUnknown)
    ['{5944E680-C92E-11CF-BFC7-444553540000}']
    (*** IDirectInputDeviceA methods ***)
    function GetCapabilities(var lpDIDevCaps: DIDEVCAPS): HRESULT; stdcall;
    function EnumObjects(lpCallback: LPDIENUMDEVICEOBJECTSCALLBACKA;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetProperty(rguidProp: PGUID; var pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function SetProperty(rguidProp: PGUID; const pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function Acquire: HRESULT; stdcall;
    function Unacquire: HRESULT; stdcall;
    function GetDeviceState(cbData: DWORD; var lpvData): HRESULT; stdcall;
    function GetDeviceData(cbObjectData: DWORD; var rgdod: DIDEVICEOBJECTDATA;
        var pdwInOut: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function SetDataFormat(const lpdf: DIDATAFORMAT): HRESULT; stdcall;
    function SetEventNotification(hEvent: THandle): HRESULT; stdcall;
    function SetCooperativeLevel(hwnd: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function GetObjectInfo(var pdidoi: DIDEVICEOBJECTINSTANCEA; dwObj: DWORD;
        dwHow: DWORD): HRESULT; stdcall;
    function GetDeviceInfo(var pdidi: DIDEVICEINSTANCEA): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD; const rguid: TGUID):
        HRESULT; stdcall;
  end;

  IDirectInputDevice = IDirectInputDeviceA;

const
  DISFFC_RESET           = $00000001;
  DISFFC_STOPALL         = $00000002;
  DISFFC_PAUSE           = $00000004;
  DISFFC_CONTINUE        = $00000008;
  DISFFC_SETACTUATORSON  = $00000010;
  DISFFC_SETACTUATORSOFF = $00000020;

  DIGFFS_EMPTY           = $00000001;
  DIGFFS_STOPPED         = $00000002;
  DIGFFS_PAUSED          = $00000004;
  DIGFFS_ACTUATORSON     = $00000010;
  DIGFFS_ACTUATORSOFF    = $00000020;
  DIGFFS_POWERON         = $00000040;
  DIGFFS_POWEROFF        = $00000080;
  DIGFFS_SAFETYSWITCHON  = $00000100;
  DIGFFS_SAFETYSWITCHOFF = $00000200;
  DIGFFS_USERFFSWITCHON  = $00000400;
  DIGFFS_USERFFSWITCHOFF = $00000800;
  DIGFFS_DEVICELOST      = $80000000;

type
  DIEFFECTINFOA = record
    dwSize: DWORD;
    guid: TGUID;
    dwEffType: DWORD;
    dwStaticParams: DWORD;
    dwDynamicParams: DWORD;
    tszName: array[0..MAX_PATH-1] of CHAR;
  end;
  LPDIEFFECTINFOA = ^DIEFFECTINFOA;

  DIEFFECTINFOW = record
    dwSize: DWORD;
    guid: TGUID;
    dwEffType: DWORD;
    dwStaticParams: DWORD;
    dwDynamicParams: DWORD;
    tszName: array[0..MAX_PATH-1] of WCHAR;
  end;
  LPDIEFFECTINFOW = ^DIEFFECTINFOW;

  DIEFFECTINFO = DIEFFECTINFOA;
  LPDIEFFECTINFO = LPDIEFFECTINFOA;

  LPDIENUMEFFECTSCALLBACKA = function(const pdei: DIEFFECTINFOA;
      pvRef: Pointer): BOOL; stdcall;
  LPDIENUMEFFECTSCALLBACKW = function(const pdei: DIEFFECTINFOW;
      pvRef: Pointer): BOOL; stdcall;

  LPDIENUMEFFECTSCALLBACK = LPDIENUMEFFECTSCALLBACKA;

  LPDIENUMCREATEDEFFECTOBJECTSCALLBACK = function(const peff:
      IDirectInputEffect; pvRef: Pointer): BOOL; stdcall;

  IDirectInputDevice2W = interface(IDirectInputDeviceW)
    ['{5944E683-C92E-11CF-BFC7-444553540000}']
    (*** IDirectInputDeviceW methods ***)
    function GetCapabilities(var lpDIDevCaps: DIDEVCAPS): HRESULT; stdcall;
    function EnumObjects(lpCallback: LPDIENUMDEVICEOBJECTSCALLBACKW;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetProperty(rguidProp: PGUID; var pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function SetProperty(rguidProp: PGUID; const pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function Acquire: HRESULT; stdcall;
    function Unacquire: HRESULT; stdcall;
    function GetDeviceState(cbData: DWORD; var lpvData): HRESULT; stdcall;
    function GetDeviceData(cbObjectData: DWORD; var rgdod: DIDEVICEOBJECTDATA;
        var pdwInOut: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function SetDataFormat(const lpdf: DIDATAFORMAT): HRESULT; stdcall;
    function SetEventNotification(hEvent: THandle): HRESULT; stdcall;
    function SetCooperativeLevel(hwnd: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function GetObjectInfo(var pdidoi: DIDEVICEOBJECTINSTANCEW; dwObj: DWORD;
        dwHow: DWORD): HRESULT; stdcall;
    function GetDeviceInfo(var pdidi: DIDEVICEINSTANCEW): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD; const rguid: TGUID):
        HRESULT; stdcall;
    (*** IDirectInputDevice2W methods ***)
    function CreateEffect(const rguid: TGUID; const lpeff: DIEFFECT;
        out ppdeff: IDirectInputEffect; punkOuter: IUnknown): HRESULT; stdcall;
    function EnumEffects(lpCallback: LPDIENUMEFFECTSCALLBACKW; pvRef: Pointer;
        dwEffType: DWORD): HRESULT; stdcall;
    function GetEffectInfo(var pdei: DIEFFECTINFOW; const rguid: TGUID):
       HRESULT; stdcall;
    function GetForceFeedbackState(var pdwOut: DWORD): HRESULT; stdcall;
    function SendForceFeedbackCommand(dwFlags: DWORD): HRESULT; stdcall;
    function EnumCreatedEffectObjects(lpCallback:
        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK; pvRef: Pointer; fl: DWORD):
        HRESULT; stdcall;
    function Escape(const pesc: DIEFFESCAPE): HRESULT; stdcall;
    function Poll: HRESULT; stdcall;
    function SendDeviceData(Arg1: DWORD; Arg2: LPDIDEVICEOBJECTDATA;
        Arg3: LPDWORD; Arg4: DWORD): HRESULT; stdcall;
  end;

  IDirectInputDevice2A = interface(IDirectInputDeviceA)
    ['{5944E682-C92E-11CF-BFC7-444553540000}']
    (*** IDirectInputDeviceA methods ***)
    function GetCapabilities(var lpDIDevCaps: DIDEVCAPS): HRESULT; stdcall;
    function EnumObjects(lpCallback: LPDIENUMDEVICEOBJECTSCALLBACKA;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetProperty(rguidProp: PGUID; var pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function SetProperty(rguidProp: PGUID; const pdiph: DIPROPHEADER): HRESULT;
        stdcall;
    function Acquire: HRESULT; stdcall;
    function Unacquire: HRESULT; stdcall;
    function GetDeviceState(cbData: DWORD; var lpvData): HRESULT; stdcall;
    function GetDeviceData(cbObjectData: DWORD; var rgdod: DIDEVICEOBJECTDATA;
        var pdwInOut: DWORD; dwFlags: DWORD): HRESULT; stdcall;
    function SetDataFormat(const lpdf: DIDATAFORMAT): HRESULT; stdcall;
    function SetEventNotification(hEvent: THandle): HRESULT; stdcall;
    function SetCooperativeLevel(hwnd: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function GetObjectInfo(var pdidoi: DIDEVICEOBJECTINSTANCEA; dwObj: DWORD;
        dwHow: DWORD): HRESULT; stdcall;
    function GetDeviceInfo(var pdidi: DIDEVICEINSTANCEA): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD; const rguid: TGUID):
        HRESULT; stdcall;
    (*** IDirectInputDevice2A methods ***)
    function CreateEffect(const rguid: TGUID; const lpeff: DIEFFECT;
        out ppdeff: IDirectInputEffect; punkOuter: IUnknown): HRESULT; stdcall;
    function EnumEffects(lpCallback: LPDIENUMEFFECTSCALLBACKA; pvRef: Pointer;
        dwEffType: DWORD): HRESULT; stdcall;
    function GetEffectInfo(var pdei: DIEFFECTINFOA; const rguid: TGUID):
        HRESULT; stdcall;
    function GetForceFeedbackState(var pdwOut: DWORD): HRESULT; stdcall;
    function SendForceFeedbackCommand(dwFlags: DWORD): HRESULT; stdcall;
    function EnumCreatedEffectObjects(lpCallback:
        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK; pvRef: Pointer; fl: DWORD):
        HRESULT; stdcall;
    function Escape(const pesc: DIEFFESCAPE): HRESULT; stdcall;
    function Poll: HRESULT; stdcall;
    function SendDeviceData(Arg1: DWORD; Arg2: LPDIDEVICEOBJECTDATA;
        Arg3: LPDWORD; Arg4: DWORD): HRESULT; stdcall;
  end;

  IDirectInputDevice2 = IDirectInputDevice2A;

(****************************************************************************
 *
 *      Mouse
 *
 ****************************************************************************)

type
  DIMOUSESTATE = packed record
    lX: Longint;
    lY: Longint;
    lZ: Longint;
    rgbButtons: array[0..3] of BYTE;
  end;
  LPDIMOUSESTATE = ^DIMOUSESTATE;

const
  _c_dfDIMouse_Objects: array[0..1] of DIOBJECTDATAFORMAT = (
    (  pguid: nil;
       dwOfs: 0;
       dwType: DIDFT_RELAXIS or DIDFT_ANYINSTANCE;
       dwFlags: 0),
    (  pguid: @GUID_Button;
       dwOfs: 12;
       dwType: DIDFT_BUTTON or DIDFT_ANYINSTANCE;
       dwFlags: 0)
  );

  c_dfDIMouse: DIDATAFORMAT = (
      dwSize: Sizeof(c_dfDIMouse);
      dwObjSize: Sizeof(DIOBJECTDATAFORMAT);
      dwFlags: DIDF_RELAXIS;
      dwDataSize: Sizeof(DIMOUSESTATE);
      dwNumObjs: High(_c_dfDIMouse_Objects)+1;
      rgodf: @_c_dfDIMouse_Objects);

(****************************************************************************
 *
 *      Keyboard
 *
 ****************************************************************************)

type
  DIKEYBOARDSTATE = array[0..255] of Byte;
  LPDIKEYBOARDSTATE = ^DIKEYBOARDSTATE;

const
  _c_dfDIKeyboard_Objects: array[0..0] of DIOBJECTDATAFORMAT = (
    (  pguid: @GUID_Key;
       dwOfs: 0;
       dwType: DIDFT_BUTTON or DIDFT_ANYINSTANCE;
       dwFlags: 0)
  );             

  c_dfDIKeyboard: DIDATAFORMAT = (
      dwSize: Sizeof(c_dfDIKeyboard);
      dwObjSize: Sizeof(DIOBJECTDATAFORMAT);
      dwFlags: DIDF_RELAXIS;
      dwDataSize: Sizeof(DIKEYBOARDSTATE);
      dwNumObjs: High(_c_dfDIKeyboard_Objects)+1;
      rgodf: @_c_dfDIKeyboard_Objects);

(****************************************************************************
 *
 *      DirectInput keyboard scan codes
 *
 ****************************************************************************)

const
  DIK_ESCAPE       = $01;
  DIK_1            = $02;
  DIK_2            = $03;
  DIK_3            = $04;
  DIK_4            = $05;
  DIK_5            = $06;
  DIK_6            = $07;
  DIK_7            = $08;
  DIK_8            = $09;
  DIK_9            = $0A;
  DIK_0            = $0B;
  DIK_EQUALS       = $0D;
  DIK_BACK         = $0E;
  DIK_TAB          = $0F;
  DIK_Q            = $10;
  DIK_W            = $11;
  DIK_E            = $12;
  DIK_R            = $13;
  DIK_T            = $14;
  DIK_Y            = $15;
  DIK_U            = $16;
  DIK_I            = $17;
  DIK_O            = $18;
  DIK_P            = $19;
  DIK_LBRACKET     = $1A;
  DIK_RBRACKET     = $1B;
  DIK_LCONTROL     = $1D;
  DIK_A            = $1E;
  DIK_S            = $1F;
  DIK_D            = $20;
  DIK_F            = $21;
  DIK_G            = $22;
  DIK_H            = $23;
  DIK_J            = $24;
  DIK_K            = $25;
  DIK_L            = $26;
  DIK_SEMICOLON    = $27;
  DIK_APOSTROPHE   = $28;
  DIK_LSHIFT       = $2A;
  DIK_BACKSLASH    = $2B;
  DIK_Z            = $2C;
  DIK_X            = $2D;
  DIK_C            = $2E;
  DIK_V            = $2F;
  DIK_B            = $30;
  DIK_N            = $31;
  DIK_M            = $32;
  DIK_COMMA        = $33;
  DIK_PERIOD       = $34;     (* . on main keyboard *)
  DIK_SLASH        = $35;     (* / on main keyboard *)
  DIK_RSHIFT       = $36;
  DIK_MULTIPLY     = $37;     (* * on main keyboard *)
  DIK_LMENU        = $38;     (* left Alt *)
  DIK_SPACE        = $39;
  DIK_CAPITAL      = $3A;
  DIK_F1           = $3B;
  DIK_F2           = $3C;
  DIK_F3           = $3D;
  DIK_F4           = $3E;
  DIK_F5           = $3F;
  DIK_F6           = $40;
  DIK_F7           = $41;
  DIK_F8           = $42;
  DIK_F9           = $43;
  DIK_F10          = $44;
  DIK_NUMLOCK      = $45;
  DIK_SCROLL       = $46;     (* Scroll Lock *)
  DIK_NUMPAD7      = $47;
  DIK_NUMPAD8      = $48;
  DIK_NUMPAD9      = $49;
  DIK_SUBTRACT     = $4A;     (* - on numeric keypad *)
  DIK_NUMPAD4      = $4B;
  DIK_NUMPAD5      = $4C;
  DIK_NUMPAD6      = $4D;
  DIK_ADD          = $4E;     (* + on numeric keypad *)
  DIK_NUMPAD1      = $4F;
  DIK_NUMPAD2      = $50;
  DIK_NUMPAD3      = $51;
  DIK_NUMPAD0      = $52;
  DIK_DECIMAL      = $53;     (* . on numeric keypad *)
  DIK_F11          = $57;
  DIK_F12          = $58;

  DIK_F13          = $64;     (*                     (NEC PC98) *)
  DIK_F14          = $65;     (*                     (NEC PC98) *)
  DIK_F15          = $66;     (*                     (NEC PC98) *)

  DIK_KANA         = $70;     (* (Japanese keyboard)            *)
  DIK_CONVERT      = $79;     (* (Japanese keyboard)            *)
  DIK_NOCONVERT    = $7B;     (* (Japanese keyboard)            *)
  DIK_YEN          = $7D;     (* (Japanese keyboard)            *)
  DIK_NUMPADEQUALS = $8D;     (* = on numeric keypad (NEC PC98) *)
  DIK_CIRCUMFLEX   = $90;     (* (Japanese keyboard)            *)
  DIK_AT           = $91;     (*                     (NEC PC98) *)
  DIK_COLON        = $92;     (*                     (NEC PC98) *)
  DIK_UNDERLINE    = $93;     (*                     (NEC PC98) *)
  DIK_KANJI        = $94;     (* (Japanese keyboard)            *)
  DIK_STOP         = $95;     (*                     (NEC PC98) *)
  DIK_AX           = $96;     (*                     (Japan AX) *)
  DIK_UNLABELED    = $97;     (*                        (J3100) *)
  DIK_RCONTROL     = $9D;
  DIK_NUMPADCOMMA  = $B3;     (* , on numeric keypad (NEC PC98) *)
  DIK_DIVIDE       = $B5;     (* / on numeric keypad *)
  DIK_SYSRQ        = $B7;
  DIK_RMENU        = $B8;     (* right Alt *)
  DIK_HOME         = $C7;     (* Home on arrow keypad *)
  DIK_UP           = $C8;     (* UpArrow on arrow keypad *)
  DIK_PRIOR        = $C9;     (* PgUp on arrow keypad *)
  DIK_LEFT         = $CB;     (* LeftArrow on arrow keypad *)
  DIK_RIGHT        = $CD;     (* RightArrow on arrow keypad *)
  DIK_END          = $CF;     (* End on arrow keypad *)
  DIK_DOWN         = $D0;     (* DownArrow on arrow keypad *)
  DIK_NEXT         = $D1;     (* PgDn on arrow keypad *)
  DIK_INSERT       = $D2;     (* Insert on arrow keypad *)
  DIK_DELETE       = $D3;     (* Delete on arrow keypad *)
  DIK_LWIN         = $DB;     (* Left Windows key *)
  DIK_RWIN         = $DC;     (* Right Windows key *)
  DIK_APPS         = $DD;     (* AppMenu key *)

(*
 *  Alternate names for keys, to facilitate transition from DOS.
 *)

  DIK_BACKSPACE    = DIK_BACK;            (* backspace *)
  DIK_NUMPADSTAR   = DIK_MULTIPLY;        (* * on numeric keypad *)
  DIK_LALT         = DIK_LMENU;           (* left Alt *)
  DIK_CAPSLOCK     = DIK_CAPITAL;         (* CapsLock *)
  DIK_NUMPADMINUS  = DIK_SUBTRACT;        (* - on numeric keypad *)
  DIK_NUMPADPLUS   = DIK_ADD;             (* + on numeric keypad *)
  DIK_NUMPADPERIOD = DIK_DECIMAL;         (* . on numeric keypad *)
  DIK_NUMPADSLASH  = DIK_DIVIDE;          (* / on numeric keypad *)
  DIK_RALT         = DIK_RMENU;           (* right Alt *)
  DIK_UPARROW      = DIK_UP;              (* UpArrow on arrow keypad *)
  DIK_PGUP         = DIK_PRIOR;           (* PgUp on arrow keypad *)
  DIK_LEFTARROW    = DIK_LEFT;            (* LeftArrow on arrow keypad *)
  DIK_RIGHTARROW   = DIK_RIGHT;           (* RightArrow on arrow keypad *)
  DIK_DOWNARROW    = DIK_DOWN;            (* DownArrow on arrow keypad *)
  DIK_PGDN         = DIK_NEXT;            (* PgDn on arrow keypad *)

(****************************************************************************
 *
 *      Joystick
 *
 ****************************************************************************)

type
  DIJOYSTATE = record
    lX: Longint;                        (* x-axis position              *)
    lY: Longint;                        (* y-axis position              *)
    lZ: Longint;                        (* z-axis position              *)
    lRx: Longint;                       (* x-axis rotation              *)
    lRy: Longint;                       (* y-axis rotation              *)
    lRz: Longint;                       (* z-axis rotation              *)
    rglSlider: array[0..1] of Longint;  (* extra axes positions         *)
    rgdwPOV: array[0..3] of DWORD;      (* POV directions               *)
    rgbButtons: array[0..31] of BYTE;   (* 32 buttons                   *)
  end;
  LPDIJOYSTATE = ^DIJOYSTATE;

  DIJOYSTATE2 = record
    lX: Longint;                        (* x-axis position              *)
    lY: Longint;                        (* y-axis position              *)
    lZ: Longint;                        (* z-axis position              *)
    lRx: Longint;                       (* x-axis rotation              *)
    lRy: Longint;                       (* y-axis rotation              *)
    lRz: Longint;                       (* z-axis rotation              *)
    rglSlider: array[0..1] of Longint;  (* extra axes positions         *)
    rgdwPOV: array[0..3] of DWORD;      (* POV directions               *)
    rgbButtons: array[0..127] of BYTE;  (* 128 buttons                  *)
    lVX: Longint;                       (* x-axis velocity              *)
    lVY: Longint;                       (* y-axis velocity              *)
    lVZ: Longint;                       (* z-axis velocity              *)
    lVRx: Longint;                      (* x-axis angular velocity      *)
    lVRy: Longint;                      (* y-axis angular velocity      *)
    lVRz: Longint;                      (* z-axis angular velocity      *)
    rglVSlider: array[0..1] of Longint; (* extra axes velocities        *)
    lAX: Longint;                       (* x-axis acceleration          *)
    lAY: Longint;                       (* y-axis acceleration          *)
    lAZ: Longint;                       (* z-axis acceleration          *)
    lARx: Longint;                      (* x-axis angular acceleration  *)
    lARy: Longint;                      (* y-axis angular acceleration  *)
    lARz: Longint;                      (* z-axis angular acceleration  *)
    rglASlider: array[0..1] of Longint; (* extra axes accelerations     *)
    lFX: Longint;                       (* x-axis force                 *)
    lFY: Longint;                       (* y-axis force                 *)
    lFZ: Longint;                       (* z-axis force                 *)
    lFRx: Longint;                      (* x-axis torque                *)
    lFRy: Longint;                      (* y-axis torque                *)
    lFRz: Longint;                      (* z-axis torque                *)
    rglFSlider: array[0..1] of Longint; (* extra axes forces            *)
  end;
  LPDIJOYSTATE2 = ^DIJOYSTATE2;

(****************************************************************************
 *
 *  IDirectInput
 *
 ****************************************************************************)

const
  DIENUM_STOP = 0;
  DIENUM_CONTINUE = 1;

type
  LPDIENUMDEVICESCALLBACKA = function(lpddi: DIDEVICEINSTANCEA;
      pvRef: Pointer): BOOL; stdcall;
  LPDIENUMDEVICESCALLBACKW = function(lpddi: DIDEVICEINSTANCEW;
      pvRef: Pointer): BOOL; stdcall;

  LPDIENUMDEVICESCALLBACK = LPDIENUMDEVICESCALLBACKA;

const
  DIEDFL_ALLDEVICES    = $00000000;
  DIEDFL_ATTACHEDONLY  = $00000001;
  DIEDFL_FORCEFEEDBACK = $00000100;

type
  IDirectInputW = interface(IUnknown)
    ['{89521361-AA8A-11CF-BFC7-444553540000}']
    (*** IDirectInputW methods ***)
    function CreateDevice(const rguid: TGUID;
        out lplpDirectInputDevice: IDirectInputDeviceW; pUnkOuter: IUnknown):
        HRESULT; stdcall;
    function EnumDevices(dwDevType: DWORD; lpCallback: LPDIENUMDEVICESCALLBACKW;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetDeviceStatus(var rguidInstance: TGUID): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD): HRESULT; stdcall;
  end;

  IDirectInputA = interface(IUnknown)
    ['{89521360-AA8A-11CF-BFC7-444553540000}']
    (*** IDirectInputA methods ***)
    function CreateDevice(const rguid: TGUID;
        out lplpDirectInputDevice: IDirectInputDeviceA; pUnkOuter: IUnknown):
        HRESULT; stdcall;
    function EnumDevices(dwDevType: DWORD; lpCallback: LPDIENUMDEVICESCALLBACKA;
        pvRef: Pointer; dwFlags: DWORD): HRESULT; stdcall;
    function GetDeviceStatus(var rguidInstance: TGUID): HRESULT; stdcall;
    function RunControlPanel(hwndOwner: HWND; dwFlags: DWORD): HRESULT; stdcall;
    function Initialize(hinst: THandle; dwVersion: DWORD): HRESULT; stdcall;
  end;

  IDirectInput = IDirectInputA;

  IDirectInput2W = interface(IDirectInputW)
    ['{5944E663-AA8A-11CF-BFC7-444553540000}']
    (*** IDirectInput2W methods ***)
    function FindDevice(Arg1: PGUID; Arg2: PWideChar; Arg3: PGUID):
        HRESULT; stdcall;
  end;

  IDirectInput2A = interface(IDirectInputA)
    ['{5944E662-AA8A-11CF-BFC7-444553540000}']
    (*** IDirectInput2A methods ***)
    function FindDevice(Arg1: PGUID; Arg2: PAnsiChar; Arg3: PGUID):
        HRESULT; stdcall;
  end;
                                  
  IDirectInput2 = IDirectInput2A;

(****************************************************************************
 *
 *  Return Codes
 *
 ****************************************************************************)

const

(*
 *  The operation completed successfully.
 *)
  DI_OK = S_OK;

(*
 *  The device exists but is not currently attached.
 *)
  DI_NOTATTACHED = S_FALSE;

(*
 *  The device buffer overflowed.  Some input was lost.
 *)
  DI_BUFFEROVERFLOW = S_FALSE;

(*
 *  The change in device properties had no effect.
 *)
  DI_PROPNOEFFECT = S_FALSE;

(*
 *  The operation had no effect.
 *)
  DI_NOEFFECT = S_FALSE;

(*
 *  The device is a polled device.  As a result, device buffering
 *  will not collect any data and event notifications will not be
 *  signalled until GetDeviceState is called.
 *)
  DI_POLLEDDEVICE = $00000002;

(*
 *  The parameters of the effect were successfully updated by
 *  IDirectInputEffect::SetParameters, but the effect was not
 *  downloaded because the device is not exclusively acquired
 *  or because the DIEP_NODOWNLOAD flag was passed.
 *)
  DI_DOWNLOADSKIPPED = $00000003;

(*
 *  The parameters of the effect were successfully updated by
 *  IDirectInputEffect::SetParameters, but in order to change
 *  the parameters, the effect needed to be restarted.
 *)
  DI_EFFECTRESTARTED = $00000004;

(*
 *  The parameters of the effect were successfully updated by
 *  IDirectInputEffect::SetParameters, but some of them were
 *  beyond the capabilities of the device and were truncated.
 *)
  DI_TRUNCATED = $00000008;

(*
 *  Equal to DI_EFFECTRESTARTED | DI_TRUNCATED.
 *)
  DI_TRUNCATEDANDRESTARTED = $0000000C;

(*
 *  The application requires a newer version of DirectInput.
 *)
  DIERR_OLDDIRECTINPUTVERSION =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_OLD_WIN_VERSION;

(*
 *  The application was written for an unsupported prerelease version
 *  of DirectInput.
 *)
  DIERR_BETADIRECTINPUTVERSION =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_RMODE_APP;

(*
 *  The object could not be created due to an incompatible driver version
 *  or mismatched or incomplete driver components.
 *)
  DIERR_BADDRIVERVER =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or
    ERROR_BAD_DRIVER_LEVEL;

(*
 * The device or device instance or effect is not registered with DirectInput.
 *)
  DIERR_DEVICENOTREG = REGDB_E_CLASSNOTREG;

(*
 * The requested object does not exist.
 *)
  DIERR_NOTFOUND =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_FILE_NOT_FOUND;

(*
 * The requested object does not exist.
 *)
  DIERR_OBJECTNOTFOUND =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_FILE_NOT_FOUND;

(*
 * An invalid parameter was passed to the returning function,
 * or the object was not in a state that admitted the function
 * to be called.
 *)
  DIERR_INVALIDPARAM = E_INVALIDARG;

(*
 * The specified interface is not supported by the object
 *)
  DIERR_NOINTERFACE = E_NOINTERFACE;

(*
 * An undetermined error occured inside the DInput subsystem
 *)
  DIERR_GENERIC = E_FAIL;

(*
 * The DInput subsystem couldn't allocate sufficient memory to complete the
 * caller's request.
 *)
  DIERR_OUTOFMEMORY = E_OUTOFMEMORY;

(*
 * The function called is not supported at this time
 *)
  DIERR_UNSUPPORTED = E_NOTIMPL;

(*
 * This object has not been initialized
 *)
  DIERR_NOTINITIALIZED =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_NOT_READY;

(*
 * This object is already initialized
 *)
  DIERR_ALREADYINITIALIZED =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or
     ERROR_ALREADY_INITIALIZED;

(*
 * This object does not support aggregation
 *)
  DIERR_NOAGGREGATION = CLASS_E_NOAGGREGATION;

(*
 * Another app has a higher priority level, preventing this call from
 * succeeding.
 *)
  DIERR_OTHERAPPHASPRIO = E_ACCESSDENIED;

(*
 * Access to the device has been lost.  It must be re-acquired.
 *)
  DIERR_INPUTLOST =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_READ_FAULT;

(*
 * The operation cannot be performed while the device is acquired.
 *)
  DIERR_ACQUIRED =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_BUSY;

(*
 * The operation cannot be performed unless the device is acquired.
 *)
  DIERR_NOTACQUIRED =
    (SEVERITY_ERROR shl 31) or (FACILITY_WIN32 shl 16) or ERROR_INVALID_ACCESS;

(*
 * The specified property cannot be changed.
 *)
  DIERR_READONLY = E_ACCESSDENIED;

(*
 * The device already has an event notification associated with it.
 *)
  DIERR_HANDLEEXISTS = E_ACCESSDENIED;

(*
 * Data is not yet available.
 *)
  E_PENDING = $80070007;

(*
 * Unable to IDirectInputJoyConfig_Acquire because the user
 * does not have sufficient privileges to change the joystick
 * configuration.
 *)
  DIERR_INSUFFICIENTPRIVS = $80040200;

(*
 * The device is full.
 *)
  DIERR_DEVICEFULL = $80040201;

(*
 * Not all the requested information fit into the buffer.
 *)
  DIERR_MOREDATA = $80040202;

(*
 * The effect is not downloaded.
 *)
  DIERR_NOTDOWNLOADED = $80040203;

(*
 *  The device cannot be reinitialized because there are still effects
 *  attached to it.
 *)
  DIERR_HASEFFECTS = $80040204;

(*
 *  The operation cannot be performed unless the device is acquired
 *  in DISCL_EXCLUSIVE mode.
 *)
  DIERR_NOTEXCLUSIVEACQUIRED = $80040205;

(*
 *  The effect could not be downloaded because essential information
 *  is missing.  For example, no axes have been associated with the
 *  effect, or no type-specific information has been created.
 *)
  DIERR_INCOMPLETEEFFECT = $80040206;

(*
 *  Attempted to read buffered device data from a device that is
 *  not buffered.
 *)
  DIERR_NOTBUFFERED = $80040207;

(*
 *  An attempt was made to modify parameters of an effect while it is
 *  playing.  Not all hardware devices support altering the parameters
 *  of an effect while it is playing.
 *)
  DIERR_EFFECTPLAYING = $80040208;



(****************************************************************************
 *
 *  Definitions for non-IDirectInput (VJoyD) features defined more recently
 *  than the current sdk files
 *
 ****************************************************************************)

(*
 * Flag to indicate that the dwReserved2 field of the JOYINFOEX structure
 * contains mini-driver specific data to be passed by VJoyD to the mini-
 * driver instead of doing a poll.
 *)
  JOY_PASSDRIVERDATA = $10000000;

(*
 * Hardware Setting indicating that the device is a headtracker
 *)
  JOY_HWS_ISHEADTRACKER = $02000000;

(*
 * Hardware Setting indicating that the VxD is used to replace
 * the standard analog polling
 *)
  JOY_HWS_ISGAMEPORTDRIVER = $04000000;

(*
 * Hardware Setting indicating that the driver needs a standard
 * gameport in order to communicate with the device.
 *)
  JOY_HWS_ISANALOGPORTDRIVER = $08000000;

(*
 * Hardware Setting indicating that VJoyD should not load this
 * driver, it will be loaded externally and will register with
 * VJoyD of it's own accord.
 *)
  JOY_HWS_AUTOLOAD = $10000000;

(*
 * Hardware Setting indicating that the driver acquires any
 * resources needed without needing a devnode through VJoyD.
 *)
  JOY_HWS_NODEVNODE = $20000000;

(*
 * Hardware Setting indicating that the VxD can be used as
 * a port 201h emulator.
 *)
  JOY_HWS_ISGAMEPORTEMULATOR = $40000000;


(*
 * Usage Setting indicating that the settings are volatile and
 * should be removed if still present on a reboot.
 *)
  JOY_US_VOLATILE = $00000008;

(****************************************************************************
 *
 *  Definitions for non-IDirectInput (VJoyD) features defined more recently
 *  than the current ddk files
 *
 ****************************************************************************)

(*
 * Poll type in which the do_other field of the JOYOEMPOLLDATA
 * structure contains mini-driver specific data passed from an app.
 *)
  JOY_OEMPOLL_PASSDRIVERDATA = 7;


function DirectInputCreate(hinst: THandle; dwVersion: DWORD;
    out ppDI: IDirectInputA; punkOuter: IUnknown): HRESULT; stdcall;

implementation

function GET_DIDEVICE_TYPE(dwDevType: DWORD): DWORD;
begin
  Result := LOBYTE(dwDevType);
end;

function GET_DIDEVICE_SUBTYPE(dwDevType: DWORD): DWORD;
begin
  Result := HIBYTE(dwDevType);
end;

function DIEFT_GETTYPE(n: DWORD): DWORD;
begin
  Result := LOBYTE(n);
end;

function DIDFT_MAKEINSTANCE(n: WORD): DWORD;
begin
  Result := n shl 8;
end;

function DIDFT_GETINSTANCE(n: DWORD): WORD;
begin
  Result := n shr 8;
end;

function DIDFT_ENUMCOLLECTION(n: WORD): DWORD;
begin
  Result := n shl 8;
end;

function DirectInputCreate; external 'dinput.dll' name 'DirectInputCreateA';

end.
