
(*==========================================================================;
 *
 *  Copyright (C) 1995,1996 Microsoft Corporation.  All Rights Reserved.
 *
 *  File:       dsound.h
 *  Content:    DirectSound include file
 *
 **************************************************************************)

unit DSound;

interface

{$Z4}
{$A+}

uses Windows, MMSystem, D3DTypes;

(*
 * GUIDS used by DirectDraw objects
 *)

const
  CLSID_DirectSound: TGUID = (D1:$47d4d946;D2:$62e8;D3:$11cf;D4:($93,$bc,$44,$45,$53,$54,$0,$0));
  CLSID_DirectSoundCapture: TGUID = (D1:$b0210780;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSound: TGUID = (D1:$279AFA83;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSoundBuffer: TGUID = (D1:$279AFA85;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSound3DListener: TGUID = (D1:$279AFA84;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSound3DBuffer: TGUID = (D1:$279AFA86;D2:$4981;D3:$11CE;D4:($A5,$21,$00,$20,$AF,$0B,$E5,$60));
  IID_IDirectSoundCapture: TGUID = (D1:$b0210781;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSoundCaptureBuffer: TGUID = (D1:$b0210782;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));
  IID_IDirectSoundNotify: TGUID = (D1:$b0210783;D2:$89cd;D3:$11d0;D4:($af,$8,$0,$a0,$c9,$25,$cd,$16));

(*============================================================================
 *
 * DirectSound Structures
 *
 * Various structures used to invoke DirectDraw.
 *
 *==========================================================================*)

type
  IDirectSound = interface;
  IDirectSoundBuffer = interface;
  IDirectSound3DListener = interface;
  IDirectSound3DBuffer = interface;
  IDirectSoundCapture = interface;
  IDirectSoundCaptureBuffer = interface;
  IDirectSoundNotify = interface;

(*
 * DSCAPS
 *)

  DSCAPS = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwMinSecondarySampleRate: DWORD;
    dwMaxSecondarySampleRate: DWORD;
    dwPrimaryBuffers: DWORD;
    dwMaxHwMixingAllBuffers: DWORD;
    dwMaxHwMixingStaticBuffers: DWORD;
    dwMaxHwMixingStreamingBuffers: DWORD;
    dwFreeHwMixingAllBuffers: DWORD;
    dwFreeHwMixingStaticBuffers: DWORD;
    dwFreeHwMixingStreamingBuffers: DWORD;
    dwMaxHw3DAllBuffers: DWORD;
    dwMaxHw3DStaticBuffers: DWORD;
    dwMaxHw3DStreamingBuffers: DWORD;
    dwFreeHw3DAllBuffers: DWORD;   
    dwFreeHw3DStaticBuffers: DWORD;   
    dwFreeHw3DStreamingBuffers: DWORD;
    dwTotalHwMemBytes: DWORD;
    dwFreeHwMemBytes: DWORD;
    dwMaxContigFreeHwMemBytes: DWORD;
    dwUnlockTransferRateHwBuffers: DWORD;
    dwPlayCpuOverheadSwBuffers: DWORD;
    dwReserved1: DWORD;
    dwReserved2: DWORD;   
  end;
  LPDSCAPS = ^DSCAPS;

(*
 * DSBCAPS
 *)

  DSBCAPS = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwBufferBytes: DWORD;
    dwUnlockTransferRate: DWORD;
    dwPlayCpuOverhead: DWORD;
  end;
  LPDSBCAPS = ^DSBCAPS;

(*
 * DSBUFFERDESC
 *)

  DSBUFFERDESC = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwBufferBytes: DWORD;
    dwReserved: DWORD;
    lpwfxFormat: PWaveFormatEx;
  end;
  LPDSBUFFERDESC = ^DSBUFFERDESC;

(*
 * DS3DBUFFER
 *)

  DS3DBUFFER = record
    dwSize: DWORD;
    vPosition: D3DVECTOR;
    vVelocity: D3DVECTOR;   
    dwInsideConeAngle: DWORD;
    dwOutsideConeAngle: DWORD;
    vConeOrientation: D3DVECTOR;   
    lConeOutsideVolume: Longint;
    flMinDistance: D3DVALUE;   
    flMaxDistance: D3DVALUE;
    dwMode: DWORD;   
  end;
  LPDS3DBUFFER = ^DS3DBUFFER;

(*
 * DS3DLISTENER
 *)

  DS3DLISTENER = record
    dwSize: DWORD;
    vPosition: D3DVECTOR;   
    vVelocity: D3DVECTOR;   
    vOrientFront: D3DVECTOR;
    vOrientTop: D3DVECTOR;
    flDistanceFactor: D3DVALUE;
    flRolloffFactor: D3DVALUE;
    flDopplerFactor: D3DVALUE;
  end;
  LPDS3DLISTENER = ^DS3DLISTENER;

(*
 * DSCCAPS
 *)

  DSCCAPS = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwFormats: DWORD;
    dwChannels: DWORD;
  end;
  LPDSCCAPS = ^DSCCAPS;

(*
 * DSCBUFFERDESC
 *)

  DSCBUFFERDESC = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwBufferBytes: DWORD;
    dwReserved: DWORD;
    lpwfxFormat: PWaveFormatEx;
  end;
  LPDSCBUFFERDESC = ^DSCBUFFERDESC;

(*
 * DSCBCAPS
 *)

  DSCBCAPS = record
    dwSize: DWORD;
    dwFlags: DWORD;
    dwBufferBytes: DWORD;
    dwReserved: DWORD;
  end;
  LPDSCBCAPS = ^DSCBCAPS;

(*
 * DSBPOSITIONNOTIFY
 *)

  DSBPOSITIONNOTIFY = record
    dwOffset: DWORD;
    hEventNotify: THandle;
  end;
  LPDSBPOSITIONNOTIFY = ^DSBPOSITIONNOTIFY;

(*
 * DirectSound API
 *)

  LPDSENUMCALLBACKW = function(lpGuid: PGUID; lpstrDescription: LPCWSTR;
    lpstrModule: LPCWSTR; lpContext: Pointer): BOOL;
  LPDSENUMCALLBACKA = function(lpGuid: PGUID; lpstrDescription: LPCSTR;
    lpstrModule: LPCSTR; lpContext: Pointer): BOOL;

  LPDSENUMCALLBACK = LPDSENUMCALLBACKA;

(*
 * IDirectSound
 *)

  IDirectSound = interface(IUnknown)
    ['{279AFA83-4981-11CE-A521-0020AF0BE560}']
    (*** IDirectSound methods ***)
    function CreateSoundBuffer(const lpDSBufferDesc: DSBUFFERDESC;
        out lplpDirectSoundBuffer: IDirectSoundBuffer;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function GetCaps(var lpDSCaps: DSCAPS): HRESULT; stdcall;
    function DuplicateSoundBuffer(lpDsbOriginal: IDirectSoundBuffer;
        out lpDsbDuplicate: IDirectSoundBuffer): HRESULT; stdcall;
    function SetCooperativeLevel(hwnd: HWND; dwLevel: DWORD): HRESULT; stdcall;
    function Compact: HRESULT; stdcall;
    function GetSpeakerConfig(var lpdwSpeakerConfig: DWORD): HRESULT; stdcall;
    function SetSpeakerConfig(dwSpeakerConfig: DWORD): HRESULT; stdcall;
    function Initialize(lpGuid: PGUID): HRESULT; stdcall;
  end;


(*
 * IDirectSoundBuffer
 *)

  IDirectSoundBuffer = interface(IUnknown)
    ['{279AFA85-4981-11CE-A521-0020AF0BE560}']
    (*** IDirectSoundBuffer methods ***)
    function GetCaps(var lpDSBufferCaps: DSBCAPS): HRESULT; stdcall;
    function GetCurrentPosition(var lpdwCurrentPlayCursor,
        lpdwCurrentWriteCursor: DWORD): HRESULT; stdcall;
    function GetFormat(var lpwfxFormat: TWaveFormatEx; dwSizeAllocated: DWORD;
        var lpdwSizeWritten: DWORD): HRESULT; stdcall;
    function GetVolume(var lplVolume: Longint): HRESULT; stdcall;
    function GetPan(var lplPan: Longint): HRESULT; stdcall;
    function GetFrequency(var lpdwFrequency: DWORD): HRESULT; stdcall;
    function GetStatus(var lpdwStatus: DWORD): HRESULT; stdcall;
    function Initialize(lpDirectSound: IDirectSound; const
        lpDSBufferDesc: DSBUFFERDESC): HRESULT; stdcall;
    function Lock(dwWriteCursor: DWORD; dwWriteBytes: DWORD;
        var lplpvAudioPtr1: Pointer; var lpdwAudioBytes1: DWORD;
        var lplpvAudioPtr2: Pointer; var lpdwAudioBytes2: DWORD;
        dwFlags: DWORD): HRESULT; stdcall;
    function Play(dwReserved1, dwReserved2: DWORD; dwFlags: DWORD): HRESULT;
        stdcall;
    function SetCurrentPosition(dwNewPosition: DWORD): HRESULT; stdcall;
    function SetFormat(const lpfxFormat: TWaveFormatEx): HRESULT; stdcall;
    function SetVolume(lVolume: Longint): HRESULT; stdcall;
    function SetPan(lPan: Longint): HRESULT; stdcall;
    function SetFrequency(dwFrequency: DWORD): HRESULT; stdcall;
    function Stop: HRESULT; stdcall;
    function Unlock(lpvAudioPtr1: Pointer; dwAudioBytes1: DWORD;
        lpvAudioPtr2: Pointer; dwAudioBytes2: DWORD): HRESULT; stdcall;
    function Restore: HRESULT; stdcall;
  end;

(*
 * IDirectSound3DListener
 *)

  IDirectSound3DListener = interface(IUnknown)
    ['{279AFA84-4981-11CE-A521-0020AF0BE560}']
    (*** IDirectSound3DListener methods ***)
    function GetAllParameters(var lpListener: DS3DLISTENER): HRESULT; stdcall;
    function GetDistanceFactor(var lpflDistanceFactor: D3DVALUE): HRESULT;
        stdcall;
    function GetDopplerFactor(var lpflDopplerFactor: D3DVALUE): HRESULT;
        stdcall;
    function GetOrientation(var lpvOrientFront, lpvOrientTop: D3DVECTOR):
        HRESULT; stdcall;
    function GetPosition(var lpvPosition: D3DVECTOR): HRESULT; stdcall;
    function GetRolloffFactor(var lpflRolloffFactor: D3DVALUE): HRESULT;
        stdcall;
    function GetVelocity(var lpvVelocity: D3DVECTOR): HRESULT; stdcall;
    function SetAllParameters(const lpListener: DS3DLISTENER; dwApply: DWORD):
        HRESULT; stdcall;
    function SetDistanceFactor(flDistanceFactor: D3DVALUE; dwApply: DWORD):
        HRESULT; stdcall;
    function SetDopplerFactor(flDopplerFactor: D3DVALUE; dwApply: DWORD):
        HRESULT; stdcall;
    function SetOrientation(xFront, yFront, zFront, xTop, yTop, zTop: D3DVALUE;
        dwApply: DWORD): HRESULT; stdcall;
    function SetPosition(x, y, z: D3DVALUE; dwApply: DWORD): HRESULT; stdcall;
    function SetRolloffFactor(flRolloffFactor: D3DVALUE; dwApply: DWORD):
        HRESULT; stdcall;
    function SetVelocity(x, y, z: D3DVALUE; dwApply: DWORD): HRESULT; stdcall;
    function CommitDeferredSettings: HRESULT; stdcall;
  end;


(*
 * IDirectSound3DBuffer
 *)
 
  IDirectSound3DBuffer = interface(IUnknown)
    ['{279AFA86-4981-11CE-A521-0020AF0BE560}']
    (*** IDirectSound3DBuffer methods ***)
    function GetAllParameters(var lpDs3dBuffer: DS3DBUFFER): HRESULT; stdcall;
    function GetConeAngles(var lpdwInsideConeAngle: DWORD;
        var lpdwOutsideConeAngle: DWORD): HRESULT; stdcall;
    function GetConeOrientation(var lpvOrientation: D3DVECTOR): HRESULT;
        stdcall;
    function GetConeOutsideVolume(var lplConeOutsideVolume: Longint): HRESULT;
        stdcall;
    function GetMaxDistance(var lpflMaxDistance: D3DVALUE): HRESULT; stdcall;
    function GetMinDistance(var lpflMinDistance: D3DVALUE): HRESULT; stdcall;
    function GetMode(var lpdwMod: DWORD): HRESULT; stdcall;
    function GetPosition(var lpvPosition: D3DVECTOR): HRESULT; stdcall;
    function GetVelocity(var lpvVelocity: D3DVECTOR): HRESULT; stdcall;
    function SetAllParameters(const lpDs3dBuffer: DS3DBUFFER; dwApply: DWORD):
        HRESULT; stdcall;
    function SetConeAngles(dwInsideConeAngle: DWORD; dwOutsideConeAngle: DWORD;
        dwApply: DWORD): HRESULT; stdcall;
    function SetConeOrientation(x, y, z: D3DVALUE; dwApply: DWORD): HRESULT; stdcall;
    function SetConeOutsideVolume(lConeOutsideVolume: Longint; dwApply: DWORD):
        HRESULT; stdcall;
    function SetMaxDistance(flMaxDistance: D3DVALUE; dwApply: DWORD): HRESULT;
        stdcall;
    function SetMinDistance(flMinDistance: D3DVALUE; dwApply: DWORD): HRESULT;
        stdcall;
    function SetMode(dwMode: DWORD; dwApply: DWORD): HRESULT; stdcall;
    function SetPosition(x, y, z: D3DVALUE; dwApply: DWORD): HRESULT; stdcall;
    function SetVelocity(x, y, z: D3DVALUE; dwApply: DWORD): HRESULT; stdcall;
  end;


(*
 * IDirectSoundCapture
 *)

  IDirectSoundCapture = interface(IUnknown)
    (*** IDirectSoundCapture methods ***)
    function CreateCaptureBuffer(const lpDSCBufferDesc: DSCBUFFERDESC;
        out lplpDirectSoundCaptureBuffer: IDirectSoundCaptureBuffer;
        pUnkOuter: IUnknown): HRESULT; stdcall;
    function GetCaps(var lpDSCCaps: DSCCAPS): HRESULT; stdcall;
    function Initialize(lpGuid: PGUID): HRESULT; stdcall;
  end;


(*
 * IDirectSoundCaptureBuffer
 *)

  IDirectSoundCaptureBuffer = interface(IUnknown)
    ['{B0210782-89CD-11D0-AF08-00A0C925CD16}']
    (*** IDirectSoundCaptureBuffer methods ***)
    function GetCaps(var lpDSCBCaps: DSCBCAPS): HRESULT; stdcall;
    function GetCurrentPosition(var lpdwCapturePosition,
        lpdwReadPosition: DWORD): HRESULT; stdcall;
    function GetFormat(var lpwfxFormat: TWaveFormatEx; dwSizeAllocated: DWORD;
        var lpdwSizeWritten: DWORD): HRESULT; stdcall;
    function GetStatus(var lpdwStatus: DWORD): HRESULT; stdcall;
    function Initialize(lpDirectSoundCapture: IDirectSoundCapture;
        const lpcDSBufferDesc: DSCBUFFERDESC): HRESULT; stdcall;
    function Lock(dwReadCursor: DWORD; dwReadBytes: DWORD;
        var lplpvAudioPtr1: Pointer; var lpdwAudioBytes1: DWORD;
        var lplpvAudioPtr2: Pointer; var lpdwAudioBytes2: DWORD;
        dwFlags: DWORD): HRESULT; stdcall;
    function Start(dwFlags: DWORD): HRESULT; stdcall;
    function Stop: HRESULT; stdcall;
    function Unlock(lpvAudioPtr1: Pointer; dwAudioBytes1: DWORD;
        lpvAudioPtr2: Pointer; dwAudioBytes2: DWORD): HRESULT; stdcall;
  end;


(*
 * IDirectSoundNotify
 *)

  IDirectSoundNotify = interface(IUnknown)
    ['{B0210783-89CD-11D0-AF08-00A0C925CD16}']
    (*** IDirectSoundNotify methods ***)
    function SetNotificationPositions(cPositionNotifies: DWORD;
        const lpcPositionNotifies: DSBPOSITIONNOTIFY): HRESULT; stdcall;
  end;

(*
 * IKsPropertySet
 *)

const
  KSPROPERTY_SUPPORT_GET = $00000001;
  KSPROPERTY_SUPPORT_SET = $00000002;

  IID_IKsPropertySet: TGUID = (D1:$31efac30;D2:$515c;D3:$11d0;D4:($a9,$aa,$00,$aa,$00,$61,$be,$93));

type
  IKsPropertySet = interface;

  IKsPropertySet = interface(IUnknown)
    ['{31EFAC30-515C-11D0-A9AA-00AA0061BE93}']
    (*** IKsPropertySet methods ***)
    function GetProperty(const PropertySetId: TGUID; PropertyId: DWORD;
        var pPropertyParams; cbPropertyParams: DWORD;
        var pPropertyData; cbPropertyData: DWORD;
        var pcbReturnedData: ULONG): HRESULT; stdcall;
    function SetProperty(const PropertySetId: TGUID; PropertyId: DWORD;
        const pPropertyParams; cbPropertyParams: DWORD;
        const pPropertyData; cbPropertyData: DWORD): HRESULT; stdcall;
    function QuerySupport(const PropertySetId: TGUID; PropertyId: DWORD;
        var pSupport: ULONG): HRESULT; stdcall;
  end;

(*
 * Return Codes
 *)

const
  DS_OK = 0;

(*
 * The call failed because resources (such as a priority level)
 * were already being used by another caller.
 *)

  DSERR_ALLOCATED = $88780000 + 10;

(*
 * The control (vol,pan,etc.) requested by the caller is not available.
 *)

  DSERR_CONTROLUNAVAIL = $88780000 + 30;

(*
 * An invalid parameter was passed to the returning function
 *)

  DSERR_INVALIDPARAM = E_INVALIDARG;

(*
 * This call is not valid for the current state of this object
 *)

  DSERR_INVALIDCALL = $88780000 + 50;

(*
 * An undetermined error occured inside the DirectSound subsystem
 *)

  DSERR_GENERIC = E_FAIL;

(*
 * The caller does not have the priority level required for the function to
 * succeed.
 *)

  DSERR_PRIOLEVELNEEDED = $88780000 + 70;

(*
 * Not enough free memory is available to complete the operation
 *)

  DSERR_OUTOFMEMORY = E_OUTOFMEMORY;

(*
 * The specified WAVE format is not supported
 *)

  DSERR_BADFORMAT = $88780000 + 100;

(*
 * The function called is not supported at this time
 *)

  DSERR_UNSUPPORTED = E_NOTIMPL;

(*
 * No sound driver is available for use
 *)

  DSERR_NODRIVER = $88780000 + 120;

(*
 * This object is already initialized
 *)

  DSERR_ALREADYINITIALIZED = $88780000 + 130;

(*
 * This object does not support aggregation
 *)

  DSERR_NOAGGREGATION = CLASS_E_NOAGGREGATION;

(*
 * The buffer memory has been lost, and must be restored.
 *)

  DSERR_BUFFERLOST = $88780000 + 150;

(*
 * Another app has a higher priority level, preventing this call from
 * succeeding.
 *)

  DSERR_OTHERAPPHASPRIO = $88780000 + 160;

(*
 * This object has not been initialized
 *)

  DSERR_UNINITIALIZED = $88780000 + 170;

(*
 * The requested COM interface is not available
 *)

  DSERR_NOINTERFACE = E_NOINTERFACE;

(*
 * Flags
 *)

  DSCAPS_PRIMARYMONO      = $00000001;
  DSCAPS_PRIMARYSTEREO    = $00000002;
  DSCAPS_PRIMARY8BIT      = $00000004;
  DSCAPS_PRIMARY16BIT     = $00000008;
  DSCAPS_CONTINUOUSRATE   = $00000010;
  DSCAPS_EMULDRIVER       = $00000020;
  DSCAPS_CERTIFIED        = $00000040;
  DSCAPS_SECONDARYMONO    = $00000100;
  DSCAPS_SECONDARYSTEREO  = $00000200;
  DSCAPS_SECONDARY8BIT    = $00000400;
  DSCAPS_SECONDARY16BIT   = $00000800;

  DSBPLAY_LOOPING         = $00000001;

  DSBSTATUS_PLAYING       = $00000001;
  DSBSTATUS_BUFFERLOST    = $00000002;
  DSBSTATUS_LOOPING       = $00000004;

  DSBLOCK_FROMWRITECURSOR = $00000001;
  DSBLOCK_ENTIREBUFFER    = $00000002;

  DSSCL_NORMAL            = $00000001;
  DSSCL_PRIORITY          = $00000002;
  DSSCL_EXCLUSIVE         = $00000003;
  DSSCL_WRITEPRIMARY      = $00000004;

  DS3DMODE_NORMAL         = $00000000;
  DS3DMODE_HEADRELATIVE   = $00000001;
  DS3DMODE_DISABLE        = $00000002;

  DS3D_IMMEDIATE          = $00000000;
  DS3D_DEFERRED           = $00000001;

  DS3D_MINDISTANCEFACTOR     = 0.0;
  DS3D_MAXDISTANCEFACTOR     = 10.0;
  DS3D_DEFAULTDISTANCEFACTOR = 1.0;

  DS3D_MINROLLOFFFACTOR      = 0.0;
  DS3D_MAXROLLOFFFACTOR      = 10.0;
  DS3D_DEFAULTROLLOFFFACTOR  = 1.0;

  DS3D_MINDOPPLERFACTOR      = 0.0;
  DS3D_MAXDOPPLERFACTOR      = 10.0;
  DS3D_DEFAULTDOPPLERFACTOR  = 1.0;

  DS3D_DEFAULTMINDISTANCE    = 1.0;
  DS3D_DEFAULTMAXDISTANCE    = 1000000000.0;

  DS3D_MINCONEANGLE          = 0;
  DS3D_MAXCONEANGLE          = 360;
  DS3D_DEFAULTCONEANGLE      = 360;

  DS3D_DEFAULTCONEOUTSIDEVOLUME = 0;

  DSBCAPS_PRIMARYBUFFER       = $00000001;
  DSBCAPS_STATIC              = $00000002;
  DSBCAPS_LOCHARDWARE         = $00000004;
  DSBCAPS_LOCSOFTWARE         = $00000008;
  DSBCAPS_CTRL3D              = $00000010;
  DSBCAPS_CTRLFREQUENCY       = $00000020;
  DSBCAPS_CTRLPAN             = $00000040;
  DSBCAPS_CTRLVOLUME          = $00000080;
  DSBCAPS_CTRLPOSITIONNOTIFY  = $00000100;
  DSBCAPS_CTRLDEFAULT         = $000000E0;
  DSBCAPS_CTRLALL             = $000001F0;
  DSBCAPS_STICKYFOCUS         = $00004000;
  DSBCAPS_GLOBALFOCUS         = $00008000;
  DSBCAPS_GETCURRENTPOSITION2 = $00010000;
  DSBCAPS_MUTE3DATMAXDISTANCE = $00020000;

  DSCBCAPS_WAVEMAPPED = $80000000;

  DSSPEAKER_HEADPHONE = $00000001;
  DSSPEAKER_MONO      = $00000002;
  DSSPEAKER_QUAD      = $00000003;
  DSSPEAKER_STEREO    = $00000004;
  DSSPEAKER_SURROUND  = $00000005;

function DSSPEAKER_COMBINED(c, g: Byte): DWORD;
function DSSPEAKER_CONFIG(a: DWORD): Byte;
function DSSPEAKER_GEOMETRY(a: DWORD): Byte;

const
  DSCCAPS_EMULDRIVER    = $00000020;

  DSCBLOCK_ENTIREBUFFER = $00000001;

  DSCBSTATUS_CAPTURING  = $00000001;
  DSCBSTATUS_LOOPING    = $00000002;

  DSCBSTART_LOOPING     = $00000001;

  DSBFREQUENCY_MIN      = 100;
  DSBFREQUENCY_MAX      = 100000;
  DSBFREQUENCY_ORIGINAL = 0;

  DSBPAN_LEFT   = -10000;
  DSBPAN_CENTER = 0;
  DSBPAN_RIGHT  = 10000;

  DSBVOLUME_MIN = -10000;
  DSBVOLUME_MAX = 0;

  DSBSIZE_MIN = 4;
  DSBSIZE_MAX = $0FFFFFFF;

  DSBPN_OFFSETSTOP = $FFFFFFFF;

function DirectSoundCreate(lpGUID: PGUID; out lpDS: IDirectSound;
  pUnkOuter: IUnknown): HRESULT; stdcall;
function DirectSoundEnumerateA(lpDSEnumCallback: LPDSENUMCALLBACKA;
  lpContext: Pointer): HRESULT; stdcall;
function DirectSoundEnumerateW(lpDSEnumCallback: LPDSENUMCALLBACKW;
  lpContext: Pointer): HRESULT; stdcall;
function DirectSoundEnumerate(lpDSEnumCallback: LPDSENUMCALLBACKA;
  lpContext: Pointer): HRESULT; stdcall;

function DirectSoundCaptureCreate(lpGUID: PGUID;
  out lplpDSC: IDirectSoundCapture; pUnkOuter: IUnknown): HRESULT; stdcall;
function DirectSoundCaptureEnumerateA(lpDSEnumCallback: LPDSENUMCALLBACKA;
  lpContext: Pointer): HRESULT; stdcall;
function DirectSoundCaptureEnumerateW(lpDSEnumCallback: LPDSENUMCALLBACKW;
  lpContext: Pointer): HRESULT; stdcall;
function DirectSoundCaptureEnumerate(lpDSEnumCallback: LPDSENUMCALLBACKA;
  lpContext: Pointer): HRESULT; stdcall;

implementation

function DSSPEAKER_COMBINED(c, g: Byte): DWORD;
begin
  Result := c or (g shl 16);
end;

function DSSPEAKER_CONFIG(a: DWORD): Byte;
begin
  Result := a;
end;

function DSSPEAKER_GEOMETRY(a: DWORD): Byte;
begin
  Result := a shr 16;
end;

function DirectSoundCreate; external 'DSound.dll';
function DirectSoundEnumerateA; external 'DSound.dll';
function DirectSoundEnumerateW; external 'DSound.dll';
function DirectSoundEnumerate; external 'DSound.dll' name 'DirectSoundEnumerateA';

function DirectSoundCaptureCreate; external 'DSound.dll';
function DirectSoundCaptureEnumerateA; external 'DSound.dll';
function DirectSoundCaptureEnumerateW; external 'DSound.dll';
function DirectSoundCaptureEnumerate; external 'DSound.dll' name 'DirectSoundCaptureEnumerateA';

end.
